ifndef __REQUIRED_RPCNDR_H_VERSION__
define __REQUIRED_RPCNDR_H_VERSION__ 500
endif
ifndef __REQUIRED_RPCSAL_H_VERSION__
define __REQUIRED_RPCSAL_H_VERSION__ 100
endif

include rpc.inc
include rpcndr.inc
ifndef __RPCNDR_H_VERSION__
.err <this stub requires an updated version of rpcndr.inc>
endif

ifndef COM_NO_WINDOWS_H
include windows.inc
include ole2.inc
endif

ifndef __d3d11sdklayers_h__
define __d3d11sdklayers_h__

include oaidl.inc
include ocidl.inc
include d3d11.inc

D3D11_SDK_LAYERS_VERSION equ ( 1 )
D3D11_DEBUG_FEATURE_FLUSH_PER_RENDER_OP equ ( 0x1 )
D3D11_DEBUG_FEATURE_FINISH_PER_RENDER_OP equ ( 0x2 )
D3D11_DEBUG_FEATURE_PRESENT_PER_RENDER_OP equ ( 0x4 )

D3D11_RLDO_FLAGS	typedef SDWORD
D3D11_RLDO_SUMMARY	equ 0x1
D3D11_RLDO_DETAIL	equ 0x2

ifndef __ID3D11Debug_INTERFACE_DEFINED__
define __ID3D11Debug_INTERFACE_DEFINED__

.comdef ID3D11Debug : public IUnknown

    SetFeatureMask	proc :UINT
    GetFeatureMask	proc
    SetPresentPerRenderOpDelay proc :UINT
    GetPresentPerRenderOpDelay proc
    SetSwapChain	proc :ptr
    GetSwapChain	proc :ptr
    ValidateContext	proc :ptr
    ReportLiveDeviceObjects proc :D3D11_RLDO_FLAGS
    ValidateContextForDispatch proc :ptr
   .ends
endif

ifndef __ID3D11SwitchToRef_INTERFACE_DEFINED__
define __ID3D11SwitchToRef_INTERFACE_DEFINED__

.comdef ID3D11SwitchToRef : public IUnknown

    SetUseRef		proc :BOOL
    GetUseRef		proc
   .ends
endif

D3D11_MESSAGE_CATEGORY	typedef SDWORD
D3D11_MESSAGE_CATEGORY_APPLICATION_DEFINED equ 0
D3D11_MESSAGE_CATEGORY_MISCELLANEOUS equ ( D3D11_MESSAGE_CATEGORY_APPLICATION_DEFINED + 1 )
D3D11_MESSAGE_CATEGORY_INITIALIZATION equ ( D3D11_MESSAGE_CATEGORY_MISCELLANEOUS + 1 )
D3D11_MESSAGE_CATEGORY_CLEANUP equ ( D3D11_MESSAGE_CATEGORY_INITIALIZATION + 1 )
D3D11_MESSAGE_CATEGORY_COMPILATION equ ( D3D11_MESSAGE_CATEGORY_CLEANUP + 1 )
D3D11_MESSAGE_CATEGORY_STATE_CREATION equ ( D3D11_MESSAGE_CATEGORY_COMPILATION + 1 )
D3D11_MESSAGE_CATEGORY_STATE_SETTING equ ( D3D11_MESSAGE_CATEGORY_STATE_CREATION + 1 )
D3D11_MESSAGE_CATEGORY_STATE_GETTING equ ( D3D11_MESSAGE_CATEGORY_STATE_SETTING + 1 )
D3D11_MESSAGE_CATEGORY_RESOURCE_MANIPULATION equ ( D3D11_MESSAGE_CATEGORY_STATE_GETTING + 1 )
D3D11_MESSAGE_CATEGORY_EXECUTION equ ( D3D11_MESSAGE_CATEGORY_RESOURCE_MANIPULATION + 1 )

D3D11_MESSAGE_SEVERITY	typedef SDWORD
D3D11_MESSAGE_SEVERITY_CORRUPTION equ 0
D3D11_MESSAGE_SEVERITY_ERROR equ ( D3D11_MESSAGE_SEVERITY_CORRUPTION + 1 )
D3D11_MESSAGE_SEVERITY_WARNING equ ( D3D11_MESSAGE_SEVERITY_ERROR + 1 )
D3D11_MESSAGE_SEVERITY_INFO equ ( D3D11_MESSAGE_SEVERITY_WARNING + 1 )

D3D11_MESSAGE_ID	typedef SDWORD
D3D11_MESSAGE_ID_UNKNOWN equ 0
D3D11_MESSAGE_ID_DEVICE_IASETVERTEXBUFFERS_HAZARD equ ( D3D11_MESSAGE_ID_UNKNOWN + 1 )
D3D11_MESSAGE_ID_DEVICE_IASETINDEXBUFFER_HAZARD equ ( D3D11_MESSAGE_ID_DEVICE_IASETVERTEXBUFFERS_HAZARD + 1 )
D3D11_MESSAGE_ID_DEVICE_VSSETSHADERRESOURCES_HAZARD equ ( D3D11_MESSAGE_ID_DEVICE_IASETINDEXBUFFER_HAZARD + 1 )
D3D11_MESSAGE_ID_DEVICE_VSSETCONSTANTBUFFERS_HAZARD equ ( D3D11_MESSAGE_ID_DEVICE_VSSETSHADERRESOURCES_HAZARD + 1 )
D3D11_MESSAGE_ID_DEVICE_GSSETSHADERRESOURCES_HAZARD equ ( D3D11_MESSAGE_ID_DEVICE_VSSETCONSTANTBUFFERS_HAZARD + 1 )
D3D11_MESSAGE_ID_DEVICE_GSSETCONSTANTBUFFERS_HAZARD equ ( D3D11_MESSAGE_ID_DEVICE_GSSETSHADERRESOURCES_HAZARD + 1 )
D3D11_MESSAGE_ID_DEVICE_PSSETSHADERRESOURCES_HAZARD equ ( D3D11_MESSAGE_ID_DEVICE_GSSETCONSTANTBUFFERS_HAZARD + 1 )
D3D11_MESSAGE_ID_DEVICE_PSSETCONSTANTBUFFERS_HAZARD equ ( D3D11_MESSAGE_ID_DEVICE_PSSETSHADERRESOURCES_HAZARD + 1 )
D3D11_MESSAGE_ID_DEVICE_OMSETRENDERTARGETS_HAZARD equ ( D3D11_MESSAGE_ID_DEVICE_PSSETCONSTANTBUFFERS_HAZARD + 1 )
D3D11_MESSAGE_ID_DEVICE_SOSETTARGETS_HAZARD equ ( D3D11_MESSAGE_ID_DEVICE_OMSETRENDERTARGETS_HAZARD + 1 )
D3D11_MESSAGE_ID_STRING_FROM_APPLICATION equ ( D3D11_MESSAGE_ID_DEVICE_SOSETTARGETS_HAZARD + 1 )
D3D11_MESSAGE_ID_CORRUPTED_THIS equ ( D3D11_MESSAGE_ID_STRING_FROM_APPLICATION + 1 )
D3D11_MESSAGE_ID_CORRUPTED_PARAMETER1 equ ( D3D11_MESSAGE_ID_CORRUPTED_THIS + 1 )
D3D11_MESSAGE_ID_CORRUPTED_PARAMETER2 equ ( D3D11_MESSAGE_ID_CORRUPTED_PARAMETER1 + 1 )
D3D11_MESSAGE_ID_CORRUPTED_PARAMETER3 equ ( D3D11_MESSAGE_ID_CORRUPTED_PARAMETER2 + 1 )
D3D11_MESSAGE_ID_CORRUPTED_PARAMETER4 equ ( D3D11_MESSAGE_ID_CORRUPTED_PARAMETER3 + 1 )
D3D11_MESSAGE_ID_CORRUPTED_PARAMETER5 equ ( D3D11_MESSAGE_ID_CORRUPTED_PARAMETER4 + 1 )
D3D11_MESSAGE_ID_CORRUPTED_PARAMETER6 equ ( D3D11_MESSAGE_ID_CORRUPTED_PARAMETER5 + 1 )
D3D11_MESSAGE_ID_CORRUPTED_PARAMETER7 equ ( D3D11_MESSAGE_ID_CORRUPTED_PARAMETER6 + 1 )
D3D11_MESSAGE_ID_CORRUPTED_PARAMETER8 equ ( D3D11_MESSAGE_ID_CORRUPTED_PARAMETER7 + 1 )
D3D11_MESSAGE_ID_CORRUPTED_PARAMETER9 equ ( D3D11_MESSAGE_ID_CORRUPTED_PARAMETER8 + 1 )
D3D11_MESSAGE_ID_CORRUPTED_PARAMETER10 equ ( D3D11_MESSAGE_ID_CORRUPTED_PARAMETER9 + 1 )
D3D11_MESSAGE_ID_CORRUPTED_PARAMETER11 equ ( D3D11_MESSAGE_ID_CORRUPTED_PARAMETER10 + 1 )
D3D11_MESSAGE_ID_CORRUPTED_PARAMETER12 equ ( D3D11_MESSAGE_ID_CORRUPTED_PARAMETER11 + 1 )
D3D11_MESSAGE_ID_CORRUPTED_PARAMETER13 equ ( D3D11_MESSAGE_ID_CORRUPTED_PARAMETER12 + 1 )
D3D11_MESSAGE_ID_CORRUPTED_PARAMETER14 equ ( D3D11_MESSAGE_ID_CORRUPTED_PARAMETER13 + 1 )
D3D11_MESSAGE_ID_CORRUPTED_PARAMETER15 equ ( D3D11_MESSAGE_ID_CORRUPTED_PARAMETER14 + 1 )
D3D11_MESSAGE_ID_CORRUPTED_MULTITHREADING equ ( D3D11_MESSAGE_ID_CORRUPTED_PARAMETER15 + 1 )
D3D11_MESSAGE_ID_MESSAGE_REPORTING_OUTOFMEMORY equ ( D3D11_MESSAGE_ID_CORRUPTED_MULTITHREADING + 1 )
D3D11_MESSAGE_ID_IASETINPUTLAYOUT_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_MESSAGE_REPORTING_OUTOFMEMORY + 1 )
D3D11_MESSAGE_ID_IASETVERTEXBUFFERS_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_IASETINPUTLAYOUT_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_IASETINDEXBUFFER_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_IASETVERTEXBUFFERS_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_VSSETSHADER_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_IASETINDEXBUFFER_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_VSSETSHADERRESOURCES_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_VSSETSHADER_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_VSSETCONSTANTBUFFERS_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_VSSETSHADERRESOURCES_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_VSSETSAMPLERS_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_VSSETCONSTANTBUFFERS_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_GSSETSHADER_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_VSSETSAMPLERS_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_GSSETSHADERRESOURCES_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_GSSETSHADER_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_GSSETCONSTANTBUFFERS_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_GSSETSHADERRESOURCES_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_GSSETSAMPLERS_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_GSSETCONSTANTBUFFERS_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_SOSETTARGETS_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_GSSETSAMPLERS_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_PSSETSHADER_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_SOSETTARGETS_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_PSSETSHADERRESOURCES_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_PSSETSHADER_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_PSSETCONSTANTBUFFERS_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_PSSETSHADERRESOURCES_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_PSSETSAMPLERS_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_PSSETCONSTANTBUFFERS_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_RSSETSTATE_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_PSSETSAMPLERS_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_OMSETBLENDSTATE_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_RSSETSTATE_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_OMSETDEPTHSTENCILSTATE_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_OMSETBLENDSTATE_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_OMSETRENDERTARGETS_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_OMSETDEPTHSTENCILSTATE_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_SETPREDICATION_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_OMSETRENDERTARGETS_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_GETPRIVATEDATA_MOREDATA equ ( D3D11_MESSAGE_ID_SETPREDICATION_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_SETPRIVATEDATA_INVALIDFREEDATA equ ( D3D11_MESSAGE_ID_GETPRIVATEDATA_MOREDATA + 1 )
D3D11_MESSAGE_ID_SETPRIVATEDATA_INVALIDIUNKNOWN equ ( D3D11_MESSAGE_ID_SETPRIVATEDATA_INVALIDFREEDATA + 1 )
D3D11_MESSAGE_ID_SETPRIVATEDATA_INVALIDFLAGS equ ( D3D11_MESSAGE_ID_SETPRIVATEDATA_INVALIDIUNKNOWN + 1 )
D3D11_MESSAGE_ID_SETPRIVATEDATA_CHANGINGPARAMS equ ( D3D11_MESSAGE_ID_SETPRIVATEDATA_INVALIDFLAGS + 1 )
D3D11_MESSAGE_ID_SETPRIVATEDATA_OUTOFMEMORY equ ( D3D11_MESSAGE_ID_SETPRIVATEDATA_CHANGINGPARAMS + 1 )
D3D11_MESSAGE_ID_CREATEBUFFER_UNRECOGNIZEDFORMAT equ ( D3D11_MESSAGE_ID_SETPRIVATEDATA_OUTOFMEMORY + 1 )
D3D11_MESSAGE_ID_CREATEBUFFER_INVALIDSAMPLES equ ( D3D11_MESSAGE_ID_CREATEBUFFER_UNRECOGNIZEDFORMAT + 1 )
D3D11_MESSAGE_ID_CREATEBUFFER_UNRECOGNIZEDUSAGE equ ( D3D11_MESSAGE_ID_CREATEBUFFER_INVALIDSAMPLES + 1 )
D3D11_MESSAGE_ID_CREATEBUFFER_UNRECOGNIZEDBINDFLAGS equ ( D3D11_MESSAGE_ID_CREATEBUFFER_UNRECOGNIZEDUSAGE + 1 )
D3D11_MESSAGE_ID_CREATEBUFFER_UNRECOGNIZEDCPUACCESSFLAGS equ ( D3D11_MESSAGE_ID_CREATEBUFFER_UNRECOGNIZEDBINDFLAGS + 1 )
D3D11_MESSAGE_ID_CREATEBUFFER_UNRECOGNIZEDMISCFLAGS equ ( D3D11_MESSAGE_ID_CREATEBUFFER_UNRECOGNIZEDCPUACCESSFLAGS + 1 )
D3D11_MESSAGE_ID_CREATEBUFFER_INVALIDCPUACCESSFLAGS equ ( D3D11_MESSAGE_ID_CREATEBUFFER_UNRECOGNIZEDMISCFLAGS + 1 )
D3D11_MESSAGE_ID_CREATEBUFFER_INVALIDBINDFLAGS equ ( D3D11_MESSAGE_ID_CREATEBUFFER_INVALIDCPUACCESSFLAGS + 1 )
D3D11_MESSAGE_ID_CREATEBUFFER_INVALIDINITIALDATA equ ( D3D11_MESSAGE_ID_CREATEBUFFER_INVALIDBINDFLAGS + 1 )
D3D11_MESSAGE_ID_CREATEBUFFER_INVALIDDIMENSIONS equ ( D3D11_MESSAGE_ID_CREATEBUFFER_INVALIDINITIALDATA + 1 )
D3D11_MESSAGE_ID_CREATEBUFFER_INVALIDMIPLEVELS equ ( D3D11_MESSAGE_ID_CREATEBUFFER_INVALIDDIMENSIONS + 1 )
D3D11_MESSAGE_ID_CREATEBUFFER_INVALIDMISCFLAGS equ ( D3D11_MESSAGE_ID_CREATEBUFFER_INVALIDMIPLEVELS + 1 )
D3D11_MESSAGE_ID_CREATEBUFFER_INVALIDARG_RETURN equ ( D3D11_MESSAGE_ID_CREATEBUFFER_INVALIDMISCFLAGS + 1 )
D3D11_MESSAGE_ID_CREATEBUFFER_OUTOFMEMORY_RETURN equ ( D3D11_MESSAGE_ID_CREATEBUFFER_INVALIDARG_RETURN + 1 )
D3D11_MESSAGE_ID_CREATEBUFFER_NULLDESC equ ( D3D11_MESSAGE_ID_CREATEBUFFER_OUTOFMEMORY_RETURN + 1 )
D3D11_MESSAGE_ID_CREATEBUFFER_INVALIDCONSTANTBUFFERBINDINGS equ ( D3D11_MESSAGE_ID_CREATEBUFFER_NULLDESC + 1 )
D3D11_MESSAGE_ID_CREATEBUFFER_LARGEALLOCATION equ ( D3D11_MESSAGE_ID_CREATEBUFFER_INVALIDCONSTANTBUFFERBINDINGS + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE1D_UNRECOGNIZEDFORMAT equ ( D3D11_MESSAGE_ID_CREATEBUFFER_LARGEALLOCATION + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE1D_UNSUPPORTEDFORMAT equ ( D3D11_MESSAGE_ID_CREATETEXTURE1D_UNRECOGNIZEDFORMAT + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE1D_INVALIDSAMPLES equ ( D3D11_MESSAGE_ID_CREATETEXTURE1D_UNSUPPORTEDFORMAT + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE1D_UNRECOGNIZEDUSAGE equ ( D3D11_MESSAGE_ID_CREATETEXTURE1D_INVALIDSAMPLES + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE1D_UNRECOGNIZEDBINDFLAGS equ ( D3D11_MESSAGE_ID_CREATETEXTURE1D_UNRECOGNIZEDUSAGE + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE1D_UNRECOGNIZEDCPUACCESSFLAGS equ ( D3D11_MESSAGE_ID_CREATETEXTURE1D_UNRECOGNIZEDBINDFLAGS + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE1D_UNRECOGNIZEDMISCFLAGS equ ( D3D11_MESSAGE_ID_CREATETEXTURE1D_UNRECOGNIZEDCPUACCESSFLAGS + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE1D_INVALIDCPUACCESSFLAGS equ ( D3D11_MESSAGE_ID_CREATETEXTURE1D_UNRECOGNIZEDMISCFLAGS + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE1D_INVALIDBINDFLAGS equ ( D3D11_MESSAGE_ID_CREATETEXTURE1D_INVALIDCPUACCESSFLAGS + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE1D_INVALIDINITIALDATA equ ( D3D11_MESSAGE_ID_CREATETEXTURE1D_INVALIDBINDFLAGS + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE1D_INVALIDDIMENSIONS equ ( D3D11_MESSAGE_ID_CREATETEXTURE1D_INVALIDINITIALDATA + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE1D_INVALIDMIPLEVELS equ ( D3D11_MESSAGE_ID_CREATETEXTURE1D_INVALIDDIMENSIONS + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE1D_INVALIDMISCFLAGS equ ( D3D11_MESSAGE_ID_CREATETEXTURE1D_INVALIDMIPLEVELS + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE1D_INVALIDARG_RETURN equ ( D3D11_MESSAGE_ID_CREATETEXTURE1D_INVALIDMISCFLAGS + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE1D_OUTOFMEMORY_RETURN equ ( D3D11_MESSAGE_ID_CREATETEXTURE1D_INVALIDARG_RETURN + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE1D_NULLDESC equ ( D3D11_MESSAGE_ID_CREATETEXTURE1D_OUTOFMEMORY_RETURN + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE1D_LARGEALLOCATION equ ( D3D11_MESSAGE_ID_CREATETEXTURE1D_NULLDESC + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE2D_UNRECOGNIZEDFORMAT equ ( D3D11_MESSAGE_ID_CREATETEXTURE1D_LARGEALLOCATION + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE2D_UNSUPPORTEDFORMAT equ ( D3D11_MESSAGE_ID_CREATETEXTURE2D_UNRECOGNIZEDFORMAT + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE2D_INVALIDSAMPLES equ ( D3D11_MESSAGE_ID_CREATETEXTURE2D_UNSUPPORTEDFORMAT + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE2D_UNRECOGNIZEDUSAGE equ ( D3D11_MESSAGE_ID_CREATETEXTURE2D_INVALIDSAMPLES + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE2D_UNRECOGNIZEDBINDFLAGS equ ( D3D11_MESSAGE_ID_CREATETEXTURE2D_UNRECOGNIZEDUSAGE + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE2D_UNRECOGNIZEDCPUACCESSFLAGS equ ( D3D11_MESSAGE_ID_CREATETEXTURE2D_UNRECOGNIZEDBINDFLAGS + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE2D_UNRECOGNIZEDMISCFLAGS equ ( D3D11_MESSAGE_ID_CREATETEXTURE2D_UNRECOGNIZEDCPUACCESSFLAGS + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE2D_INVALIDCPUACCESSFLAGS equ ( D3D11_MESSAGE_ID_CREATETEXTURE2D_UNRECOGNIZEDMISCFLAGS + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE2D_INVALIDBINDFLAGS equ ( D3D11_MESSAGE_ID_CREATETEXTURE2D_INVALIDCPUACCESSFLAGS + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE2D_INVALIDINITIALDATA equ ( D3D11_MESSAGE_ID_CREATETEXTURE2D_INVALIDBINDFLAGS + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE2D_INVALIDDIMENSIONS equ ( D3D11_MESSAGE_ID_CREATETEXTURE2D_INVALIDINITIALDATA + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE2D_INVALIDMIPLEVELS equ ( D3D11_MESSAGE_ID_CREATETEXTURE2D_INVALIDDIMENSIONS + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE2D_INVALIDMISCFLAGS equ ( D3D11_MESSAGE_ID_CREATETEXTURE2D_INVALIDMIPLEVELS + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE2D_INVALIDARG_RETURN equ ( D3D11_MESSAGE_ID_CREATETEXTURE2D_INVALIDMISCFLAGS + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE2D_OUTOFMEMORY_RETURN equ ( D3D11_MESSAGE_ID_CREATETEXTURE2D_INVALIDARG_RETURN + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE2D_NULLDESC equ ( D3D11_MESSAGE_ID_CREATETEXTURE2D_OUTOFMEMORY_RETURN + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE2D_LARGEALLOCATION equ ( D3D11_MESSAGE_ID_CREATETEXTURE2D_NULLDESC + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE3D_UNRECOGNIZEDFORMAT equ ( D3D11_MESSAGE_ID_CREATETEXTURE2D_LARGEALLOCATION + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE3D_UNSUPPORTEDFORMAT equ ( D3D11_MESSAGE_ID_CREATETEXTURE3D_UNRECOGNIZEDFORMAT + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE3D_INVALIDSAMPLES equ ( D3D11_MESSAGE_ID_CREATETEXTURE3D_UNSUPPORTEDFORMAT + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE3D_UNRECOGNIZEDUSAGE equ ( D3D11_MESSAGE_ID_CREATETEXTURE3D_INVALIDSAMPLES + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE3D_UNRECOGNIZEDBINDFLAGS equ ( D3D11_MESSAGE_ID_CREATETEXTURE3D_UNRECOGNIZEDUSAGE + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE3D_UNRECOGNIZEDCPUACCESSFLAGS equ ( D3D11_MESSAGE_ID_CREATETEXTURE3D_UNRECOGNIZEDBINDFLAGS + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE3D_UNRECOGNIZEDMISCFLAGS equ ( D3D11_MESSAGE_ID_CREATETEXTURE3D_UNRECOGNIZEDCPUACCESSFLAGS + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE3D_INVALIDCPUACCESSFLAGS equ ( D3D11_MESSAGE_ID_CREATETEXTURE3D_UNRECOGNIZEDMISCFLAGS + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE3D_INVALIDBINDFLAGS equ ( D3D11_MESSAGE_ID_CREATETEXTURE3D_INVALIDCPUACCESSFLAGS + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE3D_INVALIDINITIALDATA equ ( D3D11_MESSAGE_ID_CREATETEXTURE3D_INVALIDBINDFLAGS + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE3D_INVALIDDIMENSIONS equ ( D3D11_MESSAGE_ID_CREATETEXTURE3D_INVALIDINITIALDATA + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE3D_INVALIDMIPLEVELS equ ( D3D11_MESSAGE_ID_CREATETEXTURE3D_INVALIDDIMENSIONS + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE3D_INVALIDMISCFLAGS equ ( D3D11_MESSAGE_ID_CREATETEXTURE3D_INVALIDMIPLEVELS + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE3D_INVALIDARG_RETURN equ ( D3D11_MESSAGE_ID_CREATETEXTURE3D_INVALIDMISCFLAGS + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE3D_OUTOFMEMORY_RETURN equ ( D3D11_MESSAGE_ID_CREATETEXTURE3D_INVALIDARG_RETURN + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE3D_NULLDESC equ ( D3D11_MESSAGE_ID_CREATETEXTURE3D_OUTOFMEMORY_RETURN + 1 )
D3D11_MESSAGE_ID_CREATETEXTURE3D_LARGEALLOCATION equ ( D3D11_MESSAGE_ID_CREATETEXTURE3D_NULLDESC + 1 )
D3D11_MESSAGE_ID_CREATESHADERRESOURCEVIEW_UNRECOGNIZEDFORMAT equ ( D3D11_MESSAGE_ID_CREATETEXTURE3D_LARGEALLOCATION + 1 )
D3D11_MESSAGE_ID_CREATESHADERRESOURCEVIEW_INVALIDDESC equ ( D3D11_MESSAGE_ID_CREATESHADERRESOURCEVIEW_UNRECOGNIZEDFORMAT + 1 )
D3D11_MESSAGE_ID_CREATESHADERRESOURCEVIEW_INVALIDFORMAT equ ( D3D11_MESSAGE_ID_CREATESHADERRESOURCEVIEW_INVALIDDESC + 1 )
D3D11_MESSAGE_ID_CREATESHADERRESOURCEVIEW_INVALIDDIMENSIONS equ ( D3D11_MESSAGE_ID_CREATESHADERRESOURCEVIEW_INVALIDFORMAT + 1 )
D3D11_MESSAGE_ID_CREATESHADERRESOURCEVIEW_INVALIDRESOURCE equ ( D3D11_MESSAGE_ID_CREATESHADERRESOURCEVIEW_INVALIDDIMENSIONS + 1 )
D3D11_MESSAGE_ID_CREATESHADERRESOURCEVIEW_TOOMANYOBJECTS equ ( D3D11_MESSAGE_ID_CREATESHADERRESOURCEVIEW_INVALIDRESOURCE + 1 )
D3D11_MESSAGE_ID_CREATESHADERRESOURCEVIEW_INVALIDARG_RETURN equ ( D3D11_MESSAGE_ID_CREATESHADERRESOURCEVIEW_TOOMANYOBJECTS + 1 )
D3D11_MESSAGE_ID_CREATESHADERRESOURCEVIEW_OUTOFMEMORY_RETURN equ ( D3D11_MESSAGE_ID_CREATESHADERRESOURCEVIEW_INVALIDARG_RETURN + 1 )
D3D11_MESSAGE_ID_CREATERENDERTARGETVIEW_UNRECOGNIZEDFORMAT equ ( D3D11_MESSAGE_ID_CREATESHADERRESOURCEVIEW_OUTOFMEMORY_RETURN + 1 )
D3D11_MESSAGE_ID_CREATERENDERTARGETVIEW_UNSUPPORTEDFORMAT equ ( D3D11_MESSAGE_ID_CREATERENDERTARGETVIEW_UNRECOGNIZEDFORMAT + 1 )
D3D11_MESSAGE_ID_CREATERENDERTARGETVIEW_INVALIDDESC equ ( D3D11_MESSAGE_ID_CREATERENDERTARGETVIEW_UNSUPPORTEDFORMAT + 1 )
D3D11_MESSAGE_ID_CREATERENDERTARGETVIEW_INVALIDFORMAT equ ( D3D11_MESSAGE_ID_CREATERENDERTARGETVIEW_INVALIDDESC + 1 )
D3D11_MESSAGE_ID_CREATERENDERTARGETVIEW_INVALIDDIMENSIONS equ ( D3D11_MESSAGE_ID_CREATERENDERTARGETVIEW_INVALIDFORMAT + 1 )
D3D11_MESSAGE_ID_CREATERENDERTARGETVIEW_INVALIDRESOURCE equ ( D3D11_MESSAGE_ID_CREATERENDERTARGETVIEW_INVALIDDIMENSIONS + 1 )
D3D11_MESSAGE_ID_CREATERENDERTARGETVIEW_TOOMANYOBJECTS equ ( D3D11_MESSAGE_ID_CREATERENDERTARGETVIEW_INVALIDRESOURCE + 1 )
D3D11_MESSAGE_ID_CREATERENDERTARGETVIEW_INVALIDARG_RETURN equ ( D3D11_MESSAGE_ID_CREATERENDERTARGETVIEW_TOOMANYOBJECTS + 1 )
D3D11_MESSAGE_ID_CREATERENDERTARGETVIEW_OUTOFMEMORY_RETURN equ ( D3D11_MESSAGE_ID_CREATERENDERTARGETVIEW_INVALIDARG_RETURN + 1 )
D3D11_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_UNRECOGNIZEDFORMAT equ ( D3D11_MESSAGE_ID_CREATERENDERTARGETVIEW_OUTOFMEMORY_RETURN + 1 )
D3D11_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_INVALIDDESC equ ( D3D11_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_UNRECOGNIZEDFORMAT + 1 )
D3D11_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_INVALIDFORMAT equ ( D3D11_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_INVALIDDESC + 1 )
D3D11_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_INVALIDDIMENSIONS equ ( D3D11_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_INVALIDFORMAT + 1 )
D3D11_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_INVALIDRESOURCE equ ( D3D11_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_INVALIDDIMENSIONS + 1 )
D3D11_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_TOOMANYOBJECTS equ ( D3D11_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_INVALIDRESOURCE + 1 )
D3D11_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_INVALIDARG_RETURN equ ( D3D11_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_TOOMANYOBJECTS + 1 )
D3D11_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_OUTOFMEMORY_RETURN equ ( D3D11_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_INVALIDARG_RETURN + 1 )
D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_OUTOFMEMORY equ ( D3D11_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_OUTOFMEMORY_RETURN + 1 )
D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_TOOMANYELEMENTS equ ( D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_OUTOFMEMORY + 1 )
D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_INVALIDFORMAT equ ( D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_TOOMANYELEMENTS + 1 )
D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_INCOMPATIBLEFORMAT equ ( D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_INVALIDFORMAT + 1 )
D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_INVALIDSLOT equ ( D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_INCOMPATIBLEFORMAT + 1 )
D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_INVALIDINPUTSLOTCLASS equ ( D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_INVALIDSLOT + 1 )
D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_STEPRATESLOTCLASSMISMATCH equ ( D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_INVALIDINPUTSLOTCLASS + 1 )
D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_INVALIDSLOTCLASSCHANGE equ ( D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_STEPRATESLOTCLASSMISMATCH + 1 )
D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_INVALIDSTEPRATECHANGE equ ( D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_INVALIDSLOTCLASSCHANGE + 1 )
D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_INVALIDALIGNMENT equ ( D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_INVALIDSTEPRATECHANGE + 1 )
D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_DUPLICATESEMANTIC equ ( D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_INVALIDALIGNMENT + 1 )
D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_UNPARSEABLEINPUTSIGNATURE equ ( D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_DUPLICATESEMANTIC + 1 )
D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_NULLSEMANTIC equ ( D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_UNPARSEABLEINPUTSIGNATURE + 1 )
D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_MISSINGELEMENT equ ( D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_NULLSEMANTIC + 1 )
D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_NULLDESC equ ( D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_MISSINGELEMENT + 1 )
D3D11_MESSAGE_ID_CREATEVERTEXSHADER_OUTOFMEMORY equ ( D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_NULLDESC + 1 )
D3D11_MESSAGE_ID_CREATEVERTEXSHADER_INVALIDSHADERBYTECODE equ ( D3D11_MESSAGE_ID_CREATEVERTEXSHADER_OUTOFMEMORY + 1 )
D3D11_MESSAGE_ID_CREATEVERTEXSHADER_INVALIDSHADERTYPE equ ( D3D11_MESSAGE_ID_CREATEVERTEXSHADER_INVALIDSHADERBYTECODE + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADER_OUTOFMEMORY equ ( D3D11_MESSAGE_ID_CREATEVERTEXSHADER_INVALIDSHADERTYPE + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADER_INVALIDSHADERBYTECODE equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADER_OUTOFMEMORY + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADER_INVALIDSHADERTYPE equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADER_INVALIDSHADERBYTECODE + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_OUTOFMEMORY equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADER_INVALIDSHADERTYPE + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDSHADERBYTECODE equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_OUTOFMEMORY + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDSHADERTYPE equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDSHADERBYTECODE + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDNUMENTRIES equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDSHADERTYPE + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_OUTPUTSTREAMSTRIDEUNUSED equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDNUMENTRIES + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_UNEXPECTEDDECL equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_OUTPUTSTREAMSTRIDEUNUSED + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_EXPECTEDDECL equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_UNEXPECTEDDECL + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_OUTPUTSLOT0EXPECTED equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_EXPECTEDDECL + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDOUTPUTSLOT equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_OUTPUTSLOT0EXPECTED + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_ONLYONEELEMENTPERSLOT equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDOUTPUTSLOT + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDCOMPONENTCOUNT equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_ONLYONEELEMENTPERSLOT + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDSTARTCOMPONENTANDCOMPONENTCOUNT equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDCOMPONENTCOUNT + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDGAPDEFINITION equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDSTARTCOMPONENTANDCOMPONENTCOUNT + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_REPEATEDOUTPUT equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDGAPDEFINITION + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDOUTPUTSTREAMSTRIDE equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_REPEATEDOUTPUT + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_MISSINGSEMANTIC equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDOUTPUTSTREAMSTRIDE + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_MASKMISMATCH equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_MISSINGSEMANTIC + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_CANTHAVEONLYGAPS equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_MASKMISMATCH + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_DECLTOOCOMPLEX equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_CANTHAVEONLYGAPS + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_MISSINGOUTPUTSIGNATURE equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_DECLTOOCOMPLEX + 1 )
D3D11_MESSAGE_ID_CREATEPIXELSHADER_OUTOFMEMORY equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_MISSINGOUTPUTSIGNATURE + 1 )
D3D11_MESSAGE_ID_CREATEPIXELSHADER_INVALIDSHADERBYTECODE equ ( D3D11_MESSAGE_ID_CREATEPIXELSHADER_OUTOFMEMORY + 1 )
D3D11_MESSAGE_ID_CREATEPIXELSHADER_INVALIDSHADERTYPE equ ( D3D11_MESSAGE_ID_CREATEPIXELSHADER_INVALIDSHADERBYTECODE + 1 )
D3D11_MESSAGE_ID_CREATERASTERIZERSTATE_INVALIDFILLMODE equ ( D3D11_MESSAGE_ID_CREATEPIXELSHADER_INVALIDSHADERTYPE + 1 )
D3D11_MESSAGE_ID_CREATERASTERIZERSTATE_INVALIDCULLMODE equ ( D3D11_MESSAGE_ID_CREATERASTERIZERSTATE_INVALIDFILLMODE + 1 )
D3D11_MESSAGE_ID_CREATERASTERIZERSTATE_INVALIDDEPTHBIASCLAMP equ ( D3D11_MESSAGE_ID_CREATERASTERIZERSTATE_INVALIDCULLMODE + 1 )
D3D11_MESSAGE_ID_CREATERASTERIZERSTATE_INVALIDSLOPESCALEDDEPTHBIAS equ ( D3D11_MESSAGE_ID_CREATERASTERIZERSTATE_INVALIDDEPTHBIASCLAMP + 1 )
D3D11_MESSAGE_ID_CREATERASTERIZERSTATE_TOOMANYOBJECTS equ ( D3D11_MESSAGE_ID_CREATERASTERIZERSTATE_INVALIDSLOPESCALEDDEPTHBIAS + 1 )
D3D11_MESSAGE_ID_CREATERASTERIZERSTATE_NULLDESC equ ( D3D11_MESSAGE_ID_CREATERASTERIZERSTATE_TOOMANYOBJECTS + 1 )
D3D11_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDDEPTHWRITEMASK equ ( D3D11_MESSAGE_ID_CREATERASTERIZERSTATE_NULLDESC + 1 )
D3D11_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDDEPTHFUNC equ ( D3D11_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDDEPTHWRITEMASK + 1 )
D3D11_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDFRONTFACESTENCILFAILOP equ ( D3D11_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDDEPTHFUNC + 1 )
D3D11_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDFRONTFACESTENCILZFAILOP equ ( D3D11_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDFRONTFACESTENCILFAILOP + 1 )
D3D11_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDFRONTFACESTENCILPASSOP equ ( D3D11_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDFRONTFACESTENCILZFAILOP + 1 )
D3D11_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDFRONTFACESTENCILFUNC equ ( D3D11_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDFRONTFACESTENCILPASSOP + 1 )
D3D11_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDBACKFACESTENCILFAILOP equ ( D3D11_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDFRONTFACESTENCILFUNC + 1 )
D3D11_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDBACKFACESTENCILZFAILOP equ ( D3D11_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDBACKFACESTENCILFAILOP + 1 )
D3D11_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDBACKFACESTENCILPASSOP equ ( D3D11_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDBACKFACESTENCILZFAILOP + 1 )
D3D11_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDBACKFACESTENCILFUNC equ ( D3D11_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDBACKFACESTENCILPASSOP + 1 )
D3D11_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_TOOMANYOBJECTS equ ( D3D11_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_INVALIDBACKFACESTENCILFUNC + 1 )
D3D11_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_NULLDESC equ ( D3D11_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_TOOMANYOBJECTS + 1 )
D3D11_MESSAGE_ID_CREATEBLENDSTATE_INVALIDSRCBLEND equ ( D3D11_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_NULLDESC + 1 )
D3D11_MESSAGE_ID_CREATEBLENDSTATE_INVALIDDESTBLEND equ ( D3D11_MESSAGE_ID_CREATEBLENDSTATE_INVALIDSRCBLEND + 1 )
D3D11_MESSAGE_ID_CREATEBLENDSTATE_INVALIDBLENDOP equ ( D3D11_MESSAGE_ID_CREATEBLENDSTATE_INVALIDDESTBLEND + 1 )
D3D11_MESSAGE_ID_CREATEBLENDSTATE_INVALIDSRCBLENDALPHA equ ( D3D11_MESSAGE_ID_CREATEBLENDSTATE_INVALIDBLENDOP + 1 )
D3D11_MESSAGE_ID_CREATEBLENDSTATE_INVALIDDESTBLENDALPHA equ ( D3D11_MESSAGE_ID_CREATEBLENDSTATE_INVALIDSRCBLENDALPHA + 1 )
D3D11_MESSAGE_ID_CREATEBLENDSTATE_INVALIDBLENDOPALPHA equ ( D3D11_MESSAGE_ID_CREATEBLENDSTATE_INVALIDDESTBLENDALPHA + 1 )
D3D11_MESSAGE_ID_CREATEBLENDSTATE_INVALIDRENDERTARGETWRITEMASK equ ( D3D11_MESSAGE_ID_CREATEBLENDSTATE_INVALIDBLENDOPALPHA + 1 )
D3D11_MESSAGE_ID_CREATEBLENDSTATE_TOOMANYOBJECTS equ ( D3D11_MESSAGE_ID_CREATEBLENDSTATE_INVALIDRENDERTARGETWRITEMASK + 1 )
D3D11_MESSAGE_ID_CREATEBLENDSTATE_NULLDESC equ ( D3D11_MESSAGE_ID_CREATEBLENDSTATE_TOOMANYOBJECTS + 1 )
D3D11_MESSAGE_ID_CREATESAMPLERSTATE_INVALIDFILTER equ ( D3D11_MESSAGE_ID_CREATEBLENDSTATE_NULLDESC + 1 )
D3D11_MESSAGE_ID_CREATESAMPLERSTATE_INVALIDADDRESSU equ ( D3D11_MESSAGE_ID_CREATESAMPLERSTATE_INVALIDFILTER + 1 )
D3D11_MESSAGE_ID_CREATESAMPLERSTATE_INVALIDADDRESSV equ ( D3D11_MESSAGE_ID_CREATESAMPLERSTATE_INVALIDADDRESSU + 1 )
D3D11_MESSAGE_ID_CREATESAMPLERSTATE_INVALIDADDRESSW equ ( D3D11_MESSAGE_ID_CREATESAMPLERSTATE_INVALIDADDRESSV + 1 )
D3D11_MESSAGE_ID_CREATESAMPLERSTATE_INVALIDMIPLODBIAS equ ( D3D11_MESSAGE_ID_CREATESAMPLERSTATE_INVALIDADDRESSW + 1 )
D3D11_MESSAGE_ID_CREATESAMPLERSTATE_INVALIDMAXANISOTROPY equ ( D3D11_MESSAGE_ID_CREATESAMPLERSTATE_INVALIDMIPLODBIAS + 1 )
D3D11_MESSAGE_ID_CREATESAMPLERSTATE_INVALIDCOMPARISONFUNC equ ( D3D11_MESSAGE_ID_CREATESAMPLERSTATE_INVALIDMAXANISOTROPY + 1 )
D3D11_MESSAGE_ID_CREATESAMPLERSTATE_INVALIDMINLOD equ ( D3D11_MESSAGE_ID_CREATESAMPLERSTATE_INVALIDCOMPARISONFUNC + 1 )
D3D11_MESSAGE_ID_CREATESAMPLERSTATE_INVALIDMAXLOD equ ( D3D11_MESSAGE_ID_CREATESAMPLERSTATE_INVALIDMINLOD + 1 )
D3D11_MESSAGE_ID_CREATESAMPLERSTATE_TOOMANYOBJECTS equ ( D3D11_MESSAGE_ID_CREATESAMPLERSTATE_INVALIDMAXLOD + 1 )
D3D11_MESSAGE_ID_CREATESAMPLERSTATE_NULLDESC equ ( D3D11_MESSAGE_ID_CREATESAMPLERSTATE_TOOMANYOBJECTS + 1 )
D3D11_MESSAGE_ID_CREATEQUERYORPREDICATE_INVALIDQUERY equ ( D3D11_MESSAGE_ID_CREATESAMPLERSTATE_NULLDESC + 1 )
D3D11_MESSAGE_ID_CREATEQUERYORPREDICATE_INVALIDMISCFLAGS equ ( D3D11_MESSAGE_ID_CREATEQUERYORPREDICATE_INVALIDQUERY + 1 )
D3D11_MESSAGE_ID_CREATEQUERYORPREDICATE_UNEXPECTEDMISCFLAG equ ( D3D11_MESSAGE_ID_CREATEQUERYORPREDICATE_INVALIDMISCFLAGS + 1 )
D3D11_MESSAGE_ID_CREATEQUERYORPREDICATE_NULLDESC equ ( D3D11_MESSAGE_ID_CREATEQUERYORPREDICATE_UNEXPECTEDMISCFLAG + 1 )
D3D11_MESSAGE_ID_DEVICE_IASETPRIMITIVETOPOLOGY_TOPOLOGY_UNRECOGNIZED equ ( D3D11_MESSAGE_ID_CREATEQUERYORPREDICATE_NULLDESC + 1 )
D3D11_MESSAGE_ID_DEVICE_IASETPRIMITIVETOPOLOGY_TOPOLOGY_UNDEFINED equ ( D3D11_MESSAGE_ID_DEVICE_IASETPRIMITIVETOPOLOGY_TOPOLOGY_UNRECOGNIZED + 1 )
D3D11_MESSAGE_ID_IASETVERTEXBUFFERS_INVALIDBUFFER equ ( D3D11_MESSAGE_ID_DEVICE_IASETPRIMITIVETOPOLOGY_TOPOLOGY_UNDEFINED + 1 )
D3D11_MESSAGE_ID_DEVICE_IASETVERTEXBUFFERS_OFFSET_TOO_LARGE equ ( D3D11_MESSAGE_ID_IASETVERTEXBUFFERS_INVALIDBUFFER + 1 )
D3D11_MESSAGE_ID_DEVICE_IASETVERTEXBUFFERS_BUFFERS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_IASETVERTEXBUFFERS_OFFSET_TOO_LARGE + 1 )
D3D11_MESSAGE_ID_IASETINDEXBUFFER_INVALIDBUFFER equ ( D3D11_MESSAGE_ID_DEVICE_IASETVERTEXBUFFERS_BUFFERS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_IASETINDEXBUFFER_FORMAT_INVALID equ ( D3D11_MESSAGE_ID_IASETINDEXBUFFER_INVALIDBUFFER + 1 )
D3D11_MESSAGE_ID_DEVICE_IASETINDEXBUFFER_OFFSET_TOO_LARGE equ ( D3D11_MESSAGE_ID_DEVICE_IASETINDEXBUFFER_FORMAT_INVALID + 1 )
D3D11_MESSAGE_ID_DEVICE_IASETINDEXBUFFER_OFFSET_UNALIGNED equ ( D3D11_MESSAGE_ID_DEVICE_IASETINDEXBUFFER_OFFSET_TOO_LARGE + 1 )
D3D11_MESSAGE_ID_DEVICE_VSSETSHADERRESOURCES_VIEWS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_IASETINDEXBUFFER_OFFSET_UNALIGNED + 1 )
D3D11_MESSAGE_ID_VSSETCONSTANTBUFFERS_INVALIDBUFFER equ ( D3D11_MESSAGE_ID_DEVICE_VSSETSHADERRESOURCES_VIEWS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_VSSETCONSTANTBUFFERS_BUFFERS_EMPTY equ ( D3D11_MESSAGE_ID_VSSETCONSTANTBUFFERS_INVALIDBUFFER + 1 )
D3D11_MESSAGE_ID_DEVICE_VSSETSAMPLERS_SAMPLERS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_VSSETCONSTANTBUFFERS_BUFFERS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_GSSETSHADERRESOURCES_VIEWS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_VSSETSAMPLERS_SAMPLERS_EMPTY + 1 )
D3D11_MESSAGE_ID_GSSETCONSTANTBUFFERS_INVALIDBUFFER equ ( D3D11_MESSAGE_ID_DEVICE_GSSETSHADERRESOURCES_VIEWS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_GSSETCONSTANTBUFFERS_BUFFERS_EMPTY equ ( D3D11_MESSAGE_ID_GSSETCONSTANTBUFFERS_INVALIDBUFFER + 1 )
D3D11_MESSAGE_ID_DEVICE_GSSETSAMPLERS_SAMPLERS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_GSSETCONSTANTBUFFERS_BUFFERS_EMPTY + 1 )
D3D11_MESSAGE_ID_SOSETTARGETS_INVALIDBUFFER equ ( D3D11_MESSAGE_ID_DEVICE_GSSETSAMPLERS_SAMPLERS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_SOSETTARGETS_OFFSET_UNALIGNED equ ( D3D11_MESSAGE_ID_SOSETTARGETS_INVALIDBUFFER + 1 )
D3D11_MESSAGE_ID_DEVICE_PSSETSHADERRESOURCES_VIEWS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_SOSETTARGETS_OFFSET_UNALIGNED + 1 )
D3D11_MESSAGE_ID_PSSETCONSTANTBUFFERS_INVALIDBUFFER equ ( D3D11_MESSAGE_ID_DEVICE_PSSETSHADERRESOURCES_VIEWS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_PSSETCONSTANTBUFFERS_BUFFERS_EMPTY equ ( D3D11_MESSAGE_ID_PSSETCONSTANTBUFFERS_INVALIDBUFFER + 1 )
D3D11_MESSAGE_ID_DEVICE_PSSETSAMPLERS_SAMPLERS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_PSSETCONSTANTBUFFERS_BUFFERS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_RSSETVIEWPORTS_INVALIDVIEWPORT equ ( D3D11_MESSAGE_ID_DEVICE_PSSETSAMPLERS_SAMPLERS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_RSSETSCISSORRECTS_INVALIDSCISSOR equ ( D3D11_MESSAGE_ID_DEVICE_RSSETVIEWPORTS_INVALIDVIEWPORT + 1 )
D3D11_MESSAGE_ID_CLEARRENDERTARGETVIEW_DENORMFLUSH equ ( D3D11_MESSAGE_ID_DEVICE_RSSETSCISSORRECTS_INVALIDSCISSOR + 1 )
D3D11_MESSAGE_ID_CLEARDEPTHSTENCILVIEW_DENORMFLUSH equ ( D3D11_MESSAGE_ID_CLEARRENDERTARGETVIEW_DENORMFLUSH + 1 )
D3D11_MESSAGE_ID_CLEARDEPTHSTENCILVIEW_INVALID equ ( D3D11_MESSAGE_ID_CLEARDEPTHSTENCILVIEW_DENORMFLUSH + 1 )
D3D11_MESSAGE_ID_DEVICE_IAGETVERTEXBUFFERS_BUFFERS_EMPTY equ ( D3D11_MESSAGE_ID_CLEARDEPTHSTENCILVIEW_INVALID + 1 )
D3D11_MESSAGE_ID_DEVICE_VSGETSHADERRESOURCES_VIEWS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_IAGETVERTEXBUFFERS_BUFFERS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_VSGETCONSTANTBUFFERS_BUFFERS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_VSGETSHADERRESOURCES_VIEWS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_VSGETSAMPLERS_SAMPLERS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_VSGETCONSTANTBUFFERS_BUFFERS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_GSGETSHADERRESOURCES_VIEWS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_VSGETSAMPLERS_SAMPLERS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_GSGETCONSTANTBUFFERS_BUFFERS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_GSGETSHADERRESOURCES_VIEWS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_GSGETSAMPLERS_SAMPLERS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_GSGETCONSTANTBUFFERS_BUFFERS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_SOGETTARGETS_BUFFERS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_GSGETSAMPLERS_SAMPLERS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_PSGETSHADERRESOURCES_VIEWS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_SOGETTARGETS_BUFFERS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_PSGETCONSTANTBUFFERS_BUFFERS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_PSGETSHADERRESOURCES_VIEWS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_PSGETSAMPLERS_SAMPLERS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_PSGETCONSTANTBUFFERS_BUFFERS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_RSGETVIEWPORTS_VIEWPORTS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_PSGETSAMPLERS_SAMPLERS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_RSGETSCISSORRECTS_RECTS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_RSGETVIEWPORTS_VIEWPORTS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_GENERATEMIPS_RESOURCE_INVALID equ ( D3D11_MESSAGE_ID_DEVICE_RSGETSCISSORRECTS_RECTS_EMPTY + 1 )
D3D11_MESSAGE_ID_COPYSUBRESOURCEREGION_INVALIDDESTINATIONSUBRESOURCE equ ( D3D11_MESSAGE_ID_DEVICE_GENERATEMIPS_RESOURCE_INVALID + 1 )
D3D11_MESSAGE_ID_COPYSUBRESOURCEREGION_INVALIDSOURCESUBRESOURCE equ ( D3D11_MESSAGE_ID_COPYSUBRESOURCEREGION_INVALIDDESTINATIONSUBRESOURCE + 1 )
D3D11_MESSAGE_ID_COPYSUBRESOURCEREGION_INVALIDSOURCEBOX equ ( D3D11_MESSAGE_ID_COPYSUBRESOURCEREGION_INVALIDSOURCESUBRESOURCE + 1 )
D3D11_MESSAGE_ID_COPYSUBRESOURCEREGION_INVALIDSOURCE equ ( D3D11_MESSAGE_ID_COPYSUBRESOURCEREGION_INVALIDSOURCEBOX + 1 )
D3D11_MESSAGE_ID_COPYSUBRESOURCEREGION_INVALIDDESTINATIONSTATE equ ( D3D11_MESSAGE_ID_COPYSUBRESOURCEREGION_INVALIDSOURCE + 1 )
D3D11_MESSAGE_ID_COPYSUBRESOURCEREGION_INVALIDSOURCESTATE equ ( D3D11_MESSAGE_ID_COPYSUBRESOURCEREGION_INVALIDDESTINATIONSTATE + 1 )
D3D11_MESSAGE_ID_COPYRESOURCE_INVALIDSOURCE equ ( D3D11_MESSAGE_ID_COPYSUBRESOURCEREGION_INVALIDSOURCESTATE + 1 )
D3D11_MESSAGE_ID_COPYRESOURCE_INVALIDDESTINATIONSTATE equ ( D3D11_MESSAGE_ID_COPYRESOURCE_INVALIDSOURCE + 1 )
D3D11_MESSAGE_ID_COPYRESOURCE_INVALIDSOURCESTATE equ ( D3D11_MESSAGE_ID_COPYRESOURCE_INVALIDDESTINATIONSTATE + 1 )
D3D11_MESSAGE_ID_UPDATESUBRESOURCE_INVALIDDESTINATIONSUBRESOURCE equ ( D3D11_MESSAGE_ID_COPYRESOURCE_INVALIDSOURCESTATE + 1 )
D3D11_MESSAGE_ID_UPDATESUBRESOURCE_INVALIDDESTINATIONBOX equ ( D3D11_MESSAGE_ID_UPDATESUBRESOURCE_INVALIDDESTINATIONSUBRESOURCE + 1 )
D3D11_MESSAGE_ID_UPDATESUBRESOURCE_INVALIDDESTINATIONSTATE equ ( D3D11_MESSAGE_ID_UPDATESUBRESOURCE_INVALIDDESTINATIONBOX + 1 )
D3D11_MESSAGE_ID_DEVICE_RESOLVESUBRESOURCE_DESTINATION_INVALID equ ( D3D11_MESSAGE_ID_UPDATESUBRESOURCE_INVALIDDESTINATIONSTATE + 1 )
D3D11_MESSAGE_ID_DEVICE_RESOLVESUBRESOURCE_DESTINATION_SUBRESOURCE_INVALID equ ( D3D11_MESSAGE_ID_DEVICE_RESOLVESUBRESOURCE_DESTINATION_INVALID + 1 )
D3D11_MESSAGE_ID_DEVICE_RESOLVESUBRESOURCE_SOURCE_INVALID equ ( D3D11_MESSAGE_ID_DEVICE_RESOLVESUBRESOURCE_DESTINATION_SUBRESOURCE_INVALID + 1 )
D3D11_MESSAGE_ID_DEVICE_RESOLVESUBRESOURCE_SOURCE_SUBRESOURCE_INVALID equ ( D3D11_MESSAGE_ID_DEVICE_RESOLVESUBRESOURCE_SOURCE_INVALID + 1 )
D3D11_MESSAGE_ID_DEVICE_RESOLVESUBRESOURCE_FORMAT_INVALID equ ( D3D11_MESSAGE_ID_DEVICE_RESOLVESUBRESOURCE_SOURCE_SUBRESOURCE_INVALID + 1 )
D3D11_MESSAGE_ID_BUFFER_MAP_INVALIDMAPTYPE equ ( D3D11_MESSAGE_ID_DEVICE_RESOLVESUBRESOURCE_FORMAT_INVALID + 1 )
D3D11_MESSAGE_ID_BUFFER_MAP_INVALIDFLAGS equ ( D3D11_MESSAGE_ID_BUFFER_MAP_INVALIDMAPTYPE + 1 )
D3D11_MESSAGE_ID_BUFFER_MAP_ALREADYMAPPED equ ( D3D11_MESSAGE_ID_BUFFER_MAP_INVALIDFLAGS + 1 )
D3D11_MESSAGE_ID_BUFFER_MAP_DEVICEREMOVED_RETURN equ ( D3D11_MESSAGE_ID_BUFFER_MAP_ALREADYMAPPED + 1 )
D3D11_MESSAGE_ID_BUFFER_UNMAP_NOTMAPPED equ ( D3D11_MESSAGE_ID_BUFFER_MAP_DEVICEREMOVED_RETURN + 1 )
D3D11_MESSAGE_ID_TEXTURE1D_MAP_INVALIDMAPTYPE equ ( D3D11_MESSAGE_ID_BUFFER_UNMAP_NOTMAPPED + 1 )
D3D11_MESSAGE_ID_TEXTURE1D_MAP_INVALIDSUBRESOURCE equ ( D3D11_MESSAGE_ID_TEXTURE1D_MAP_INVALIDMAPTYPE + 1 )
D3D11_MESSAGE_ID_TEXTURE1D_MAP_INVALIDFLAGS equ ( D3D11_MESSAGE_ID_TEXTURE1D_MAP_INVALIDSUBRESOURCE + 1 )
D3D11_MESSAGE_ID_TEXTURE1D_MAP_ALREADYMAPPED equ ( D3D11_MESSAGE_ID_TEXTURE1D_MAP_INVALIDFLAGS + 1 )
D3D11_MESSAGE_ID_TEXTURE1D_MAP_DEVICEREMOVED_RETURN equ ( D3D11_MESSAGE_ID_TEXTURE1D_MAP_ALREADYMAPPED + 1 )
D3D11_MESSAGE_ID_TEXTURE1D_UNMAP_INVALIDSUBRESOURCE equ ( D3D11_MESSAGE_ID_TEXTURE1D_MAP_DEVICEREMOVED_RETURN + 1 )
D3D11_MESSAGE_ID_TEXTURE1D_UNMAP_NOTMAPPED equ ( D3D11_MESSAGE_ID_TEXTURE1D_UNMAP_INVALIDSUBRESOURCE + 1 )
D3D11_MESSAGE_ID_TEXTURE2D_MAP_INVALIDMAPTYPE equ ( D3D11_MESSAGE_ID_TEXTURE1D_UNMAP_NOTMAPPED + 1 )
D3D11_MESSAGE_ID_TEXTURE2D_MAP_INVALIDSUBRESOURCE equ ( D3D11_MESSAGE_ID_TEXTURE2D_MAP_INVALIDMAPTYPE + 1 )
D3D11_MESSAGE_ID_TEXTURE2D_MAP_INVALIDFLAGS equ ( D3D11_MESSAGE_ID_TEXTURE2D_MAP_INVALIDSUBRESOURCE + 1 )
D3D11_MESSAGE_ID_TEXTURE2D_MAP_ALREADYMAPPED equ ( D3D11_MESSAGE_ID_TEXTURE2D_MAP_INVALIDFLAGS + 1 )
D3D11_MESSAGE_ID_TEXTURE2D_MAP_DEVICEREMOVED_RETURN equ ( D3D11_MESSAGE_ID_TEXTURE2D_MAP_ALREADYMAPPED + 1 )
D3D11_MESSAGE_ID_TEXTURE2D_UNMAP_INVALIDSUBRESOURCE equ ( D3D11_MESSAGE_ID_TEXTURE2D_MAP_DEVICEREMOVED_RETURN + 1 )
D3D11_MESSAGE_ID_TEXTURE2D_UNMAP_NOTMAPPED equ ( D3D11_MESSAGE_ID_TEXTURE2D_UNMAP_INVALIDSUBRESOURCE + 1 )
D3D11_MESSAGE_ID_TEXTURE3D_MAP_INVALIDMAPTYPE equ ( D3D11_MESSAGE_ID_TEXTURE2D_UNMAP_NOTMAPPED + 1 )
D3D11_MESSAGE_ID_TEXTURE3D_MAP_INVALIDSUBRESOURCE equ ( D3D11_MESSAGE_ID_TEXTURE3D_MAP_INVALIDMAPTYPE + 1 )
D3D11_MESSAGE_ID_TEXTURE3D_MAP_INVALIDFLAGS equ ( D3D11_MESSAGE_ID_TEXTURE3D_MAP_INVALIDSUBRESOURCE + 1 )
D3D11_MESSAGE_ID_TEXTURE3D_MAP_ALREADYMAPPED equ ( D3D11_MESSAGE_ID_TEXTURE3D_MAP_INVALIDFLAGS + 1 )
D3D11_MESSAGE_ID_TEXTURE3D_MAP_DEVICEREMOVED_RETURN equ ( D3D11_MESSAGE_ID_TEXTURE3D_MAP_ALREADYMAPPED + 1 )
D3D11_MESSAGE_ID_TEXTURE3D_UNMAP_INVALIDSUBRESOURCE equ ( D3D11_MESSAGE_ID_TEXTURE3D_MAP_DEVICEREMOVED_RETURN + 1 )
D3D11_MESSAGE_ID_TEXTURE3D_UNMAP_NOTMAPPED equ ( D3D11_MESSAGE_ID_TEXTURE3D_UNMAP_INVALIDSUBRESOURCE + 1 )
D3D11_MESSAGE_ID_CHECKFORMATSUPPORT_FORMAT_DEPRECATED equ ( D3D11_MESSAGE_ID_TEXTURE3D_UNMAP_NOTMAPPED + 1 )
D3D11_MESSAGE_ID_CHECKMULTISAMPLEQUALITYLEVELS_FORMAT_DEPRECATED equ ( D3D11_MESSAGE_ID_CHECKFORMATSUPPORT_FORMAT_DEPRECATED + 1 )
D3D11_MESSAGE_ID_SETEXCEPTIONMODE_UNRECOGNIZEDFLAGS equ ( D3D11_MESSAGE_ID_CHECKMULTISAMPLEQUALITYLEVELS_FORMAT_DEPRECATED + 1 )
D3D11_MESSAGE_ID_SETEXCEPTIONMODE_INVALIDARG_RETURN equ ( D3D11_MESSAGE_ID_SETEXCEPTIONMODE_UNRECOGNIZEDFLAGS + 1 )
D3D11_MESSAGE_ID_SETEXCEPTIONMODE_DEVICEREMOVED_RETURN equ ( D3D11_MESSAGE_ID_SETEXCEPTIONMODE_INVALIDARG_RETURN + 1 )
D3D11_MESSAGE_ID_REF_SIMULATING_INFINITELY_FAST_HARDWARE equ ( D3D11_MESSAGE_ID_SETEXCEPTIONMODE_DEVICEREMOVED_RETURN + 1 )
D3D11_MESSAGE_ID_REF_THREADING_MODE equ ( D3D11_MESSAGE_ID_REF_SIMULATING_INFINITELY_FAST_HARDWARE + 1 )
D3D11_MESSAGE_ID_REF_UMDRIVER_EXCEPTION equ ( D3D11_MESSAGE_ID_REF_THREADING_MODE + 1 )
D3D11_MESSAGE_ID_REF_KMDRIVER_EXCEPTION equ ( D3D11_MESSAGE_ID_REF_UMDRIVER_EXCEPTION + 1 )
D3D11_MESSAGE_ID_REF_HARDWARE_EXCEPTION equ ( D3D11_MESSAGE_ID_REF_KMDRIVER_EXCEPTION + 1 )
D3D11_MESSAGE_ID_REF_ACCESSING_INDEXABLE_TEMP_OUT_OF_RANGE equ ( D3D11_MESSAGE_ID_REF_HARDWARE_EXCEPTION + 1 )
D3D11_MESSAGE_ID_REF_PROBLEM_PARSING_SHADER equ ( D3D11_MESSAGE_ID_REF_ACCESSING_INDEXABLE_TEMP_OUT_OF_RANGE + 1 )
D3D11_MESSAGE_ID_REF_OUT_OF_MEMORY equ ( D3D11_MESSAGE_ID_REF_PROBLEM_PARSING_SHADER + 1 )
D3D11_MESSAGE_ID_REF_INFO equ ( D3D11_MESSAGE_ID_REF_OUT_OF_MEMORY + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_VERTEXPOS_OVERFLOW equ ( D3D11_MESSAGE_ID_REF_INFO + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAWINDEXED_INDEXPOS_OVERFLOW equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_VERTEXPOS_OVERFLOW + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAWINSTANCED_VERTEXPOS_OVERFLOW equ ( D3D11_MESSAGE_ID_DEVICE_DRAWINDEXED_INDEXPOS_OVERFLOW + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAWINSTANCED_INSTANCEPOS_OVERFLOW equ ( D3D11_MESSAGE_ID_DEVICE_DRAWINSTANCED_VERTEXPOS_OVERFLOW + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAWINDEXEDINSTANCED_INSTANCEPOS_OVERFLOW equ ( D3D11_MESSAGE_ID_DEVICE_DRAWINSTANCED_INSTANCEPOS_OVERFLOW + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAWINDEXEDINSTANCED_INDEXPOS_OVERFLOW equ ( D3D11_MESSAGE_ID_DEVICE_DRAWINDEXEDINSTANCED_INSTANCEPOS_OVERFLOW + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_VERTEX_SHADER_NOT_SET equ ( D3D11_MESSAGE_ID_DEVICE_DRAWINDEXEDINSTANCED_INDEXPOS_OVERFLOW + 1 )
D3D11_MESSAGE_ID_DEVICE_SHADER_LINKAGE_SEMANTICNAME_NOT_FOUND equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_VERTEX_SHADER_NOT_SET + 1 )
D3D11_MESSAGE_ID_DEVICE_SHADER_LINKAGE_REGISTERINDEX equ ( D3D11_MESSAGE_ID_DEVICE_SHADER_LINKAGE_SEMANTICNAME_NOT_FOUND + 1 )
D3D11_MESSAGE_ID_DEVICE_SHADER_LINKAGE_COMPONENTTYPE equ ( D3D11_MESSAGE_ID_DEVICE_SHADER_LINKAGE_REGISTERINDEX + 1 )
D3D11_MESSAGE_ID_DEVICE_SHADER_LINKAGE_REGISTERMASK equ ( D3D11_MESSAGE_ID_DEVICE_SHADER_LINKAGE_COMPONENTTYPE + 1 )
D3D11_MESSAGE_ID_DEVICE_SHADER_LINKAGE_SYSTEMVALUE equ ( D3D11_MESSAGE_ID_DEVICE_SHADER_LINKAGE_REGISTERMASK + 1 )
D3D11_MESSAGE_ID_DEVICE_SHADER_LINKAGE_NEVERWRITTEN_ALWAYSREADS equ ( D3D11_MESSAGE_ID_DEVICE_SHADER_LINKAGE_SYSTEMVALUE + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_VERTEX_BUFFER_NOT_SET equ ( D3D11_MESSAGE_ID_DEVICE_SHADER_LINKAGE_NEVERWRITTEN_ALWAYSREADS + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_INPUTLAYOUT_NOT_SET equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_VERTEX_BUFFER_NOT_SET + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_CONSTANT_BUFFER_NOT_SET equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_INPUTLAYOUT_NOT_SET + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_CONSTANT_BUFFER_TOO_SMALL equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_CONSTANT_BUFFER_NOT_SET + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_SAMPLER_NOT_SET equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_CONSTANT_BUFFER_TOO_SMALL + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_SHADERRESOURCEVIEW_NOT_SET equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_SAMPLER_NOT_SET + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_VIEW_DIMENSION_MISMATCH equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_SHADERRESOURCEVIEW_NOT_SET + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_VERTEX_BUFFER_STRIDE_TOO_SMALL equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_VIEW_DIMENSION_MISMATCH + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_VERTEX_BUFFER_TOO_SMALL equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_VERTEX_BUFFER_STRIDE_TOO_SMALL + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_INDEX_BUFFER_NOT_SET equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_VERTEX_BUFFER_TOO_SMALL + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_INDEX_BUFFER_FORMAT_INVALID equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_INDEX_BUFFER_NOT_SET + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_INDEX_BUFFER_TOO_SMALL equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_INDEX_BUFFER_FORMAT_INVALID + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_GS_INPUT_PRIMITIVE_MISMATCH equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_INDEX_BUFFER_TOO_SMALL + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_RESOURCE_RETURN_TYPE_MISMATCH equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_GS_INPUT_PRIMITIVE_MISMATCH + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_POSITION_NOT_PRESENT equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_RESOURCE_RETURN_TYPE_MISMATCH + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_OUTPUT_STREAM_NOT_SET equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_POSITION_NOT_PRESENT + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_BOUND_RESOURCE_MAPPED equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_OUTPUT_STREAM_NOT_SET + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_INVALID_PRIMITIVETOPOLOGY equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_BOUND_RESOURCE_MAPPED + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_VERTEX_OFFSET_UNALIGNED equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_INVALID_PRIMITIVETOPOLOGY + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_VERTEX_STRIDE_UNALIGNED equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_VERTEX_OFFSET_UNALIGNED + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_INDEX_OFFSET_UNALIGNED equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_VERTEX_STRIDE_UNALIGNED + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_OUTPUT_STREAM_OFFSET_UNALIGNED equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_INDEX_OFFSET_UNALIGNED + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_RESOURCE_FORMAT_LD_UNSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_OUTPUT_STREAM_OFFSET_UNALIGNED + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_RESOURCE_FORMAT_SAMPLE_UNSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_RESOURCE_FORMAT_LD_UNSUPPORTED + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_RESOURCE_FORMAT_SAMPLE_C_UNSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_RESOURCE_FORMAT_SAMPLE_UNSUPPORTED + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_RESOURCE_MULTISAMPLE_UNSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_RESOURCE_FORMAT_SAMPLE_C_UNSUPPORTED + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_SO_TARGETS_BOUND_WITHOUT_SOURCE equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_RESOURCE_MULTISAMPLE_UNSUPPORTED + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_SO_STRIDE_LARGER_THAN_BUFFER equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_SO_TARGETS_BOUND_WITHOUT_SOURCE + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_OM_RENDER_TARGET_DOES_NOT_SUPPORT_BLENDING equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_SO_STRIDE_LARGER_THAN_BUFFER + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_OM_DUAL_SOURCE_BLENDING_CAN_ONLY_HAVE_RENDER_TARGET_0 equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_OM_RENDER_TARGET_DOES_NOT_SUPPORT_BLENDING + 1 )
D3D11_MESSAGE_ID_DEVICE_REMOVAL_PROCESS_AT_FAULT equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_OM_DUAL_SOURCE_BLENDING_CAN_ONLY_HAVE_RENDER_TARGET_0 + 1 )
D3D11_MESSAGE_ID_DEVICE_REMOVAL_PROCESS_POSSIBLY_AT_FAULT equ ( D3D11_MESSAGE_ID_DEVICE_REMOVAL_PROCESS_AT_FAULT + 1 )
D3D11_MESSAGE_ID_DEVICE_REMOVAL_PROCESS_NOT_AT_FAULT equ ( D3D11_MESSAGE_ID_DEVICE_REMOVAL_PROCESS_POSSIBLY_AT_FAULT + 1 )
D3D11_MESSAGE_ID_DEVICE_OPEN_SHARED_RESOURCE_INVALIDARG_RETURN equ ( D3D11_MESSAGE_ID_DEVICE_REMOVAL_PROCESS_NOT_AT_FAULT + 1 )
D3D11_MESSAGE_ID_DEVICE_OPEN_SHARED_RESOURCE_OUTOFMEMORY_RETURN equ ( D3D11_MESSAGE_ID_DEVICE_OPEN_SHARED_RESOURCE_INVALIDARG_RETURN + 1 )
D3D11_MESSAGE_ID_DEVICE_OPEN_SHARED_RESOURCE_BADINTERFACE_RETURN equ ( D3D11_MESSAGE_ID_DEVICE_OPEN_SHARED_RESOURCE_OUTOFMEMORY_RETURN + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_VIEWPORT_NOT_SET equ ( D3D11_MESSAGE_ID_DEVICE_OPEN_SHARED_RESOURCE_BADINTERFACE_RETURN + 1 )
D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_TRAILING_DIGIT_IN_SEMANTIC equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_VIEWPORT_NOT_SET + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_TRAILING_DIGIT_IN_SEMANTIC equ ( D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_TRAILING_DIGIT_IN_SEMANTIC + 1 )
D3D11_MESSAGE_ID_DEVICE_RSSETVIEWPORTS_DENORMFLUSH equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_TRAILING_DIGIT_IN_SEMANTIC + 1 )
D3D11_MESSAGE_ID_OMSETRENDERTARGETS_INVALIDVIEW equ ( D3D11_MESSAGE_ID_DEVICE_RSSETVIEWPORTS_DENORMFLUSH + 1 )
D3D11_MESSAGE_ID_DEVICE_SETTEXTFILTERSIZE_INVALIDDIMENSIONS equ ( D3D11_MESSAGE_ID_OMSETRENDERTARGETS_INVALIDVIEW + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_SAMPLER_MISMATCH equ ( D3D11_MESSAGE_ID_DEVICE_SETTEXTFILTERSIZE_INVALIDDIMENSIONS + 1 )
D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_TYPE_MISMATCH equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_SAMPLER_MISMATCH + 1 )
D3D11_MESSAGE_ID_BLENDSTATE_GETDESC_LEGACY equ ( D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_TYPE_MISMATCH + 1 )
D3D11_MESSAGE_ID_SHADERRESOURCEVIEW_GETDESC_LEGACY equ ( D3D11_MESSAGE_ID_BLENDSTATE_GETDESC_LEGACY + 1 )
D3D11_MESSAGE_ID_CREATEQUERY_OUTOFMEMORY_RETURN equ ( D3D11_MESSAGE_ID_SHADERRESOURCEVIEW_GETDESC_LEGACY + 1 )
D3D11_MESSAGE_ID_CREATEPREDICATE_OUTOFMEMORY_RETURN equ ( D3D11_MESSAGE_ID_CREATEQUERY_OUTOFMEMORY_RETURN + 1 )
D3D11_MESSAGE_ID_CREATECOUNTER_OUTOFRANGE_COUNTER equ ( D3D11_MESSAGE_ID_CREATEPREDICATE_OUTOFMEMORY_RETURN + 1 )
D3D11_MESSAGE_ID_CREATECOUNTER_SIMULTANEOUS_ACTIVE_COUNTERS_EXHAUSTED equ ( D3D11_MESSAGE_ID_CREATECOUNTER_OUTOFRANGE_COUNTER + 1 )
D3D11_MESSAGE_ID_CREATECOUNTER_UNSUPPORTED_WELLKNOWN_COUNTER equ ( D3D11_MESSAGE_ID_CREATECOUNTER_SIMULTANEOUS_ACTIVE_COUNTERS_EXHAUSTED + 1 )
D3D11_MESSAGE_ID_CREATECOUNTER_OUTOFMEMORY_RETURN equ ( D3D11_MESSAGE_ID_CREATECOUNTER_UNSUPPORTED_WELLKNOWN_COUNTER + 1 )
D3D11_MESSAGE_ID_CREATECOUNTER_NONEXCLUSIVE_RETURN equ ( D3D11_MESSAGE_ID_CREATECOUNTER_OUTOFMEMORY_RETURN + 1 )
D3D11_MESSAGE_ID_CREATECOUNTER_NULLDESC equ ( D3D11_MESSAGE_ID_CREATECOUNTER_NONEXCLUSIVE_RETURN + 1 )
D3D11_MESSAGE_ID_CHECKCOUNTER_OUTOFRANGE_COUNTER equ ( D3D11_MESSAGE_ID_CREATECOUNTER_NULLDESC + 1 )
D3D11_MESSAGE_ID_CHECKCOUNTER_UNSUPPORTED_WELLKNOWN_COUNTER equ ( D3D11_MESSAGE_ID_CHECKCOUNTER_OUTOFRANGE_COUNTER + 1 )
D3D11_MESSAGE_ID_SETPREDICATION_INVALID_PREDICATE_STATE equ ( D3D11_MESSAGE_ID_CHECKCOUNTER_UNSUPPORTED_WELLKNOWN_COUNTER + 1 )
D3D11_MESSAGE_ID_QUERY_BEGIN_UNSUPPORTED equ ( D3D11_MESSAGE_ID_SETPREDICATION_INVALID_PREDICATE_STATE + 1 )
D3D11_MESSAGE_ID_PREDICATE_BEGIN_DURING_PREDICATION equ ( D3D11_MESSAGE_ID_QUERY_BEGIN_UNSUPPORTED + 1 )
D3D11_MESSAGE_ID_QUERY_BEGIN_DUPLICATE equ ( D3D11_MESSAGE_ID_PREDICATE_BEGIN_DURING_PREDICATION + 1 )
D3D11_MESSAGE_ID_QUERY_BEGIN_ABANDONING_PREVIOUS_RESULTS equ ( D3D11_MESSAGE_ID_QUERY_BEGIN_DUPLICATE + 1 )
D3D11_MESSAGE_ID_PREDICATE_END_DURING_PREDICATION equ ( D3D11_MESSAGE_ID_QUERY_BEGIN_ABANDONING_PREVIOUS_RESULTS + 1 )
D3D11_MESSAGE_ID_QUERY_END_ABANDONING_PREVIOUS_RESULTS equ ( D3D11_MESSAGE_ID_PREDICATE_END_DURING_PREDICATION + 1 )
D3D11_MESSAGE_ID_QUERY_END_WITHOUT_BEGIN equ ( D3D11_MESSAGE_ID_QUERY_END_ABANDONING_PREVIOUS_RESULTS + 1 )
D3D11_MESSAGE_ID_QUERY_GETDATA_INVALID_DATASIZE equ ( D3D11_MESSAGE_ID_QUERY_END_WITHOUT_BEGIN + 1 )
D3D11_MESSAGE_ID_QUERY_GETDATA_INVALID_FLAGS equ ( D3D11_MESSAGE_ID_QUERY_GETDATA_INVALID_DATASIZE + 1 )
D3D11_MESSAGE_ID_QUERY_GETDATA_INVALID_CALL equ ( D3D11_MESSAGE_ID_QUERY_GETDATA_INVALID_FLAGS + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_PS_OUTPUT_TYPE_MISMATCH equ ( D3D11_MESSAGE_ID_QUERY_GETDATA_INVALID_CALL + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_RESOURCE_FORMAT_GATHER_UNSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_PS_OUTPUT_TYPE_MISMATCH + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_INVALID_USE_OF_CENTER_MULTISAMPLE_PATTERN equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_RESOURCE_FORMAT_GATHER_UNSUPPORTED + 1 )
D3D11_MESSAGE_ID_DEVICE_IASETVERTEXBUFFERS_STRIDE_TOO_LARGE equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_INVALID_USE_OF_CENTER_MULTISAMPLE_PATTERN + 1 )
D3D11_MESSAGE_ID_DEVICE_IASETVERTEXBUFFERS_INVALIDRANGE equ ( D3D11_MESSAGE_ID_DEVICE_IASETVERTEXBUFFERS_STRIDE_TOO_LARGE + 1 )
D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_EMPTY_LAYOUT equ ( D3D11_MESSAGE_ID_DEVICE_IASETVERTEXBUFFERS_INVALIDRANGE + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_RESOURCE_SAMPLE_COUNT_MISMATCH equ ( D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_EMPTY_LAYOUT + 1 )
D3D11_MESSAGE_ID_D3D10_MESSAGES_END equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_RESOURCE_SAMPLE_COUNT_MISMATCH + 1 )
D3D11_MESSAGE_ID_D3D10L9_MESSAGES_START equ 0x100000
D3D11_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_STENCIL_NO_TWO_SIDED equ ( D3D11_MESSAGE_ID_D3D10L9_MESSAGES_START + 1 )
D3D11_MESSAGE_ID_CREATERASTERIZERSTATE_DepthBiasClamp_NOT_SUPPORTED equ ( D3D11_MESSAGE_ID_CREATEDEPTHSTENCILSTATE_STENCIL_NO_TWO_SIDED + 1 )
D3D11_MESSAGE_ID_CREATESAMPLERSTATE_NO_COMPARISON_SUPPORT equ ( D3D11_MESSAGE_ID_CREATERASTERIZERSTATE_DepthBiasClamp_NOT_SUPPORTED + 1 )
D3D11_MESSAGE_ID_CREATESAMPLERSTATE_EXCESSIVE_ANISOTROPY equ ( D3D11_MESSAGE_ID_CREATESAMPLERSTATE_NO_COMPARISON_SUPPORT + 1 )
D3D11_MESSAGE_ID_CREATESAMPLERSTATE_BORDER_OUT_OF_RANGE equ ( D3D11_MESSAGE_ID_CREATESAMPLERSTATE_EXCESSIVE_ANISOTROPY + 1 )
D3D11_MESSAGE_ID_VSSETSAMPLERS_NOT_SUPPORTED equ ( D3D11_MESSAGE_ID_CREATESAMPLERSTATE_BORDER_OUT_OF_RANGE + 1 )
D3D11_MESSAGE_ID_VSSETSAMPLERS_TOO_MANY_SAMPLERS equ ( D3D11_MESSAGE_ID_VSSETSAMPLERS_NOT_SUPPORTED + 1 )
D3D11_MESSAGE_ID_PSSETSAMPLERS_TOO_MANY_SAMPLERS equ ( D3D11_MESSAGE_ID_VSSETSAMPLERS_TOO_MANY_SAMPLERS + 1 )
D3D11_MESSAGE_ID_CREATERESOURCE_NO_ARRAYS equ ( D3D11_MESSAGE_ID_PSSETSAMPLERS_TOO_MANY_SAMPLERS + 1 )
D3D11_MESSAGE_ID_CREATERESOURCE_NO_VB_AND_IB_BIND equ ( D3D11_MESSAGE_ID_CREATERESOURCE_NO_ARRAYS + 1 )
D3D11_MESSAGE_ID_CREATERESOURCE_NO_TEXTURE_1D equ ( D3D11_MESSAGE_ID_CREATERESOURCE_NO_VB_AND_IB_BIND + 1 )
D3D11_MESSAGE_ID_CREATERESOURCE_DIMENSION_OUT_OF_RANGE equ ( D3D11_MESSAGE_ID_CREATERESOURCE_NO_TEXTURE_1D + 1 )
D3D11_MESSAGE_ID_CREATERESOURCE_NOT_BINDABLE_AS_SHADER_RESOURCE equ ( D3D11_MESSAGE_ID_CREATERESOURCE_DIMENSION_OUT_OF_RANGE + 1 )
D3D11_MESSAGE_ID_OMSETRENDERTARGETS_TOO_MANY_RENDER_TARGETS equ ( D3D11_MESSAGE_ID_CREATERESOURCE_NOT_BINDABLE_AS_SHADER_RESOURCE + 1 )
D3D11_MESSAGE_ID_OMSETRENDERTARGETS_NO_DIFFERING_BIT_DEPTHS equ ( D3D11_MESSAGE_ID_OMSETRENDERTARGETS_TOO_MANY_RENDER_TARGETS + 1 )
D3D11_MESSAGE_ID_IASETVERTEXBUFFERS_BAD_BUFFER_INDEX equ ( D3D11_MESSAGE_ID_OMSETRENDERTARGETS_NO_DIFFERING_BIT_DEPTHS + 1 )
D3D11_MESSAGE_ID_DEVICE_RSSETVIEWPORTS_TOO_MANY_VIEWPORTS equ ( D3D11_MESSAGE_ID_IASETVERTEXBUFFERS_BAD_BUFFER_INDEX + 1 )
D3D11_MESSAGE_ID_DEVICE_IASETPRIMITIVETOPOLOGY_ADJACENCY_UNSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_RSSETVIEWPORTS_TOO_MANY_VIEWPORTS + 1 )
D3D11_MESSAGE_ID_DEVICE_RSSETSCISSORRECTS_TOO_MANY_SCISSORS equ ( D3D11_MESSAGE_ID_DEVICE_IASETPRIMITIVETOPOLOGY_ADJACENCY_UNSUPPORTED + 1 )
D3D11_MESSAGE_ID_COPYRESOURCE_ONLY_TEXTURE_2D_WITHIN_GPU_MEMORY equ ( D3D11_MESSAGE_ID_DEVICE_RSSETSCISSORRECTS_TOO_MANY_SCISSORS + 1 )
D3D11_MESSAGE_ID_COPYRESOURCE_NO_TEXTURE_3D_READBACK equ ( D3D11_MESSAGE_ID_COPYRESOURCE_ONLY_TEXTURE_2D_WITHIN_GPU_MEMORY + 1 )
D3D11_MESSAGE_ID_COPYRESOURCE_NO_TEXTURE_ONLY_READBACK equ ( D3D11_MESSAGE_ID_COPYRESOURCE_NO_TEXTURE_3D_READBACK + 1 )
D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_UNSUPPORTED_FORMAT equ ( D3D11_MESSAGE_ID_COPYRESOURCE_NO_TEXTURE_ONLY_READBACK + 1 )
D3D11_MESSAGE_ID_CREATEBLENDSTATE_NO_ALPHA_TO_COVERAGE equ ( D3D11_MESSAGE_ID_CREATEINPUTLAYOUT_UNSUPPORTED_FORMAT + 1 )
D3D11_MESSAGE_ID_CREATERASTERIZERSTATE_DepthClipEnable_MUST_BE_TRUE equ ( D3D11_MESSAGE_ID_CREATEBLENDSTATE_NO_ALPHA_TO_COVERAGE + 1 )
D3D11_MESSAGE_ID_DRAWINDEXED_STARTINDEXLOCATION_MUST_BE_POSITIVE equ ( D3D11_MESSAGE_ID_CREATERASTERIZERSTATE_DepthClipEnable_MUST_BE_TRUE + 1 )
D3D11_MESSAGE_ID_CREATESHADERRESOURCEVIEW_MUST_USE_LOWEST_LOD equ ( D3D11_MESSAGE_ID_DRAWINDEXED_STARTINDEXLOCATION_MUST_BE_POSITIVE + 1 )
D3D11_MESSAGE_ID_CREATESAMPLERSTATE_MINLOD_MUST_NOT_BE_FRACTIONAL equ ( D3D11_MESSAGE_ID_CREATESHADERRESOURCEVIEW_MUST_USE_LOWEST_LOD + 1 )
D3D11_MESSAGE_ID_CREATESAMPLERSTATE_MAXLOD_MUST_BE_FLT_MAX equ ( D3D11_MESSAGE_ID_CREATESAMPLERSTATE_MINLOD_MUST_NOT_BE_FRACTIONAL + 1 )
D3D11_MESSAGE_ID_CREATESHADERRESOURCEVIEW_FIRSTARRAYSLICE_MUST_BE_ZERO equ ( D3D11_MESSAGE_ID_CREATESAMPLERSTATE_MAXLOD_MUST_BE_FLT_MAX + 1 )
D3D11_MESSAGE_ID_CREATESHADERRESOURCEVIEW_CUBES_MUST_HAVE_6_SIDES equ ( D3D11_MESSAGE_ID_CREATESHADERRESOURCEVIEW_FIRSTARRAYSLICE_MUST_BE_ZERO + 1 )
D3D11_MESSAGE_ID_CREATERESOURCE_NOT_BINDABLE_AS_RENDER_TARGET equ ( D3D11_MESSAGE_ID_CREATESHADERRESOURCEVIEW_CUBES_MUST_HAVE_6_SIDES + 1 )
D3D11_MESSAGE_ID_CREATERESOURCE_NO_DWORD_INDEX_BUFFER equ ( D3D11_MESSAGE_ID_CREATERESOURCE_NOT_BINDABLE_AS_RENDER_TARGET + 1 )
D3D11_MESSAGE_ID_CREATERESOURCE_MSAA_PRECLUDES_SHADER_RESOURCE equ ( D3D11_MESSAGE_ID_CREATERESOURCE_NO_DWORD_INDEX_BUFFER + 1 )
D3D11_MESSAGE_ID_CREATERESOURCE_PRESENTATION_PRECLUDES_SHADER_RESOURCE equ ( D3D11_MESSAGE_ID_CREATERESOURCE_MSAA_PRECLUDES_SHADER_RESOURCE + 1 )
D3D11_MESSAGE_ID_CREATEBLENDSTATE_NO_INDEPENDENT_BLEND_ENABLE equ ( D3D11_MESSAGE_ID_CREATERESOURCE_PRESENTATION_PRECLUDES_SHADER_RESOURCE + 1 )
D3D11_MESSAGE_ID_CREATEBLENDSTATE_NO_INDEPENDENT_WRITE_MASKS equ ( D3D11_MESSAGE_ID_CREATEBLENDSTATE_NO_INDEPENDENT_BLEND_ENABLE + 1 )
D3D11_MESSAGE_ID_CREATERESOURCE_NO_STREAM_OUT equ ( D3D11_MESSAGE_ID_CREATEBLENDSTATE_NO_INDEPENDENT_WRITE_MASKS + 1 )
D3D11_MESSAGE_ID_CREATERESOURCE_ONLY_VB_IB_FOR_BUFFERS equ ( D3D11_MESSAGE_ID_CREATERESOURCE_NO_STREAM_OUT + 1 )
D3D11_MESSAGE_ID_CREATERESOURCE_NO_AUTOGEN_FOR_VOLUMES equ ( D3D11_MESSAGE_ID_CREATERESOURCE_ONLY_VB_IB_FOR_BUFFERS + 1 )
D3D11_MESSAGE_ID_CREATERESOURCE_DXGI_FORMAT_R8G8B8A8_CANNOT_BE_SHARED equ ( D3D11_MESSAGE_ID_CREATERESOURCE_NO_AUTOGEN_FOR_VOLUMES + 1 )
D3D11_MESSAGE_ID_VSSHADERRESOURCES_NOT_SUPPORTED equ ( D3D11_MESSAGE_ID_CREATERESOURCE_DXGI_FORMAT_R8G8B8A8_CANNOT_BE_SHARED + 1 )
D3D11_MESSAGE_ID_GEOMETRY_SHADER_NOT_SUPPORTED equ ( D3D11_MESSAGE_ID_VSSHADERRESOURCES_NOT_SUPPORTED + 1 )
D3D11_MESSAGE_ID_STREAM_OUT_NOT_SUPPORTED equ ( D3D11_MESSAGE_ID_GEOMETRY_SHADER_NOT_SUPPORTED + 1 )
D3D11_MESSAGE_ID_TEXT_FILTER_NOT_SUPPORTED equ ( D3D11_MESSAGE_ID_STREAM_OUT_NOT_SUPPORTED + 1 )
D3D11_MESSAGE_ID_CREATEBLENDSTATE_NO_SEPARATE_ALPHA_BLEND equ ( D3D11_MESSAGE_ID_TEXT_FILTER_NOT_SUPPORTED + 1 )
D3D11_MESSAGE_ID_CREATEBLENDSTATE_NO_MRT_BLEND equ ( D3D11_MESSAGE_ID_CREATEBLENDSTATE_NO_SEPARATE_ALPHA_BLEND + 1 )
D3D11_MESSAGE_ID_CREATEBLENDSTATE_OPERATION_NOT_SUPPORTED equ ( D3D11_MESSAGE_ID_CREATEBLENDSTATE_NO_MRT_BLEND + 1 )
D3D11_MESSAGE_ID_CREATESAMPLERSTATE_NO_MIRRORONCE equ ( D3D11_MESSAGE_ID_CREATEBLENDSTATE_OPERATION_NOT_SUPPORTED + 1 )
D3D11_MESSAGE_ID_DRAWINSTANCED_NOT_SUPPORTED equ ( D3D11_MESSAGE_ID_CREATESAMPLERSTATE_NO_MIRRORONCE + 1 )
D3D11_MESSAGE_ID_DRAWINDEXEDINSTANCED_NOT_SUPPORTED_BELOW_9_3 equ ( D3D11_MESSAGE_ID_DRAWINSTANCED_NOT_SUPPORTED + 1 )
D3D11_MESSAGE_ID_DRAWINDEXED_POINTLIST_UNSUPPORTED equ ( D3D11_MESSAGE_ID_DRAWINDEXEDINSTANCED_NOT_SUPPORTED_BELOW_9_3 + 1 )
D3D11_MESSAGE_ID_SETBLENDSTATE_SAMPLE_MASK_CANNOT_BE_ZERO equ ( D3D11_MESSAGE_ID_DRAWINDEXED_POINTLIST_UNSUPPORTED + 1 )
D3D11_MESSAGE_ID_CREATERESOURCE_DIMENSION_EXCEEDS_FEATURE_LEVEL_DEFINITION equ ( D3D11_MESSAGE_ID_SETBLENDSTATE_SAMPLE_MASK_CANNOT_BE_ZERO + 1 )
D3D11_MESSAGE_ID_CREATERESOURCE_ONLY_SINGLE_MIP_LEVEL_DEPTH_STENCIL_SUPPORTED equ ( D3D11_MESSAGE_ID_CREATERESOURCE_DIMENSION_EXCEEDS_FEATURE_LEVEL_DEFINITION + 1 )
D3D11_MESSAGE_ID_DEVICE_RSSETSCISSORRECTS_NEGATIVESCISSOR equ ( D3D11_MESSAGE_ID_CREATERESOURCE_ONLY_SINGLE_MIP_LEVEL_DEPTH_STENCIL_SUPPORTED + 1 )
D3D11_MESSAGE_ID_SLOT_ZERO_MUST_BE_D3D10_INPUT_PER_VERTEX_DATA equ ( D3D11_MESSAGE_ID_DEVICE_RSSETSCISSORRECTS_NEGATIVESCISSOR + 1 )
D3D11_MESSAGE_ID_CREATERESOURCE_NON_POW_2_MIPMAP equ ( D3D11_MESSAGE_ID_SLOT_ZERO_MUST_BE_D3D10_INPUT_PER_VERTEX_DATA + 1 )
D3D11_MESSAGE_ID_CREATESAMPLERSTATE_BORDER_NOT_SUPPORTED equ ( D3D11_MESSAGE_ID_CREATERESOURCE_NON_POW_2_MIPMAP + 1 )
D3D11_MESSAGE_ID_OMSETRENDERTARGETS_NO_SRGB_MRT equ ( D3D11_MESSAGE_ID_CREATESAMPLERSTATE_BORDER_NOT_SUPPORTED + 1 )
D3D11_MESSAGE_ID_D3D10L9_MESSAGES_END equ ( D3D11_MESSAGE_ID_OMSETRENDERTARGETS_NO_SRGB_MRT + 1 )
D3D11_MESSAGE_ID_D3D11_MESSAGES_START equ 0x200000
D3D11_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_INVALIDFLAGS equ ( D3D11_MESSAGE_ID_D3D11_MESSAGES_START + 1 )
D3D11_MESSAGE_ID_CREATEVERTEXSHADER_INVALIDCLASSLINKAGE equ ( D3D11_MESSAGE_ID_CREATEDEPTHSTENCILVIEW_INVALIDFLAGS + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADER_INVALIDCLASSLINKAGE equ ( D3D11_MESSAGE_ID_CREATEVERTEXSHADER_INVALIDCLASSLINKAGE + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDNUMSTREAMS equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADER_INVALIDCLASSLINKAGE + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDSTREAMTORASTERIZER equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDNUMSTREAMS + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_UNEXPECTEDSTREAMS equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDSTREAMTORASTERIZER + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDCLASSLINKAGE equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_UNEXPECTEDSTREAMS + 1 )
D3D11_MESSAGE_ID_CREATEPIXELSHADER_INVALIDCLASSLINKAGE equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDCLASSLINKAGE + 1 )
D3D11_MESSAGE_ID_CREATEDEFERREDCONTEXT_INVALID_COMMANDLISTFLAGS equ ( D3D11_MESSAGE_ID_CREATEPIXELSHADER_INVALIDCLASSLINKAGE + 1 )
D3D11_MESSAGE_ID_CREATEDEFERREDCONTEXT_SINGLETHREADED equ ( D3D11_MESSAGE_ID_CREATEDEFERREDCONTEXT_INVALID_COMMANDLISTFLAGS + 1 )
D3D11_MESSAGE_ID_CREATEDEFERREDCONTEXT_INVALIDARG_RETURN equ ( D3D11_MESSAGE_ID_CREATEDEFERREDCONTEXT_SINGLETHREADED + 1 )
D3D11_MESSAGE_ID_CREATEDEFERREDCONTEXT_INVALID_CALL_RETURN equ ( D3D11_MESSAGE_ID_CREATEDEFERREDCONTEXT_INVALIDARG_RETURN + 1 )
D3D11_MESSAGE_ID_CREATEDEFERREDCONTEXT_OUTOFMEMORY_RETURN equ ( D3D11_MESSAGE_ID_CREATEDEFERREDCONTEXT_INVALID_CALL_RETURN + 1 )
D3D11_MESSAGE_ID_FINISHDISPLAYLIST_ONIMMEDIATECONTEXT equ ( D3D11_MESSAGE_ID_CREATEDEFERREDCONTEXT_OUTOFMEMORY_RETURN + 1 )
D3D11_MESSAGE_ID_FINISHDISPLAYLIST_OUTOFMEMORY_RETURN equ ( D3D11_MESSAGE_ID_FINISHDISPLAYLIST_ONIMMEDIATECONTEXT + 1 )
D3D11_MESSAGE_ID_FINISHDISPLAYLIST_INVALID_CALL_RETURN equ ( D3D11_MESSAGE_ID_FINISHDISPLAYLIST_OUTOFMEMORY_RETURN + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDSTREAM equ ( D3D11_MESSAGE_ID_FINISHDISPLAYLIST_INVALID_CALL_RETURN + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_UNEXPECTEDENTRIES equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDSTREAM + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_UNEXPECTEDSTRIDES equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_UNEXPECTEDENTRIES + 1 )
D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDNUMSTRIDES equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_UNEXPECTEDSTRIDES + 1 )
D3D11_MESSAGE_ID_DEVICE_HSSETSHADERRESOURCES_HAZARD equ ( D3D11_MESSAGE_ID_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_INVALIDNUMSTRIDES + 1 )
D3D11_MESSAGE_ID_DEVICE_HSSETCONSTANTBUFFERS_HAZARD equ ( D3D11_MESSAGE_ID_DEVICE_HSSETSHADERRESOURCES_HAZARD + 1 )
D3D11_MESSAGE_ID_HSSETSHADERRESOURCES_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_DEVICE_HSSETCONSTANTBUFFERS_HAZARD + 1 )
D3D11_MESSAGE_ID_HSSETCONSTANTBUFFERS_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_HSSETSHADERRESOURCES_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_CREATEHULLSHADER_INVALIDCALL equ ( D3D11_MESSAGE_ID_HSSETCONSTANTBUFFERS_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_CREATEHULLSHADER_OUTOFMEMORY equ ( D3D11_MESSAGE_ID_CREATEHULLSHADER_INVALIDCALL + 1 )
D3D11_MESSAGE_ID_CREATEHULLSHADER_INVALIDSHADERBYTECODE equ ( D3D11_MESSAGE_ID_CREATEHULLSHADER_OUTOFMEMORY + 1 )
D3D11_MESSAGE_ID_CREATEHULLSHADER_INVALIDSHADERTYPE equ ( D3D11_MESSAGE_ID_CREATEHULLSHADER_INVALIDSHADERBYTECODE + 1 )
D3D11_MESSAGE_ID_CREATEHULLSHADER_INVALIDCLASSLINKAGE equ ( D3D11_MESSAGE_ID_CREATEHULLSHADER_INVALIDSHADERTYPE + 1 )
D3D11_MESSAGE_ID_DEVICE_HSSETSHADERRESOURCES_VIEWS_EMPTY equ ( D3D11_MESSAGE_ID_CREATEHULLSHADER_INVALIDCLASSLINKAGE + 1 )
D3D11_MESSAGE_ID_HSSETCONSTANTBUFFERS_INVALIDBUFFER equ ( D3D11_MESSAGE_ID_DEVICE_HSSETSHADERRESOURCES_VIEWS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_HSSETCONSTANTBUFFERS_BUFFERS_EMPTY equ ( D3D11_MESSAGE_ID_HSSETCONSTANTBUFFERS_INVALIDBUFFER + 1 )
D3D11_MESSAGE_ID_DEVICE_HSSETSAMPLERS_SAMPLERS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_HSSETCONSTANTBUFFERS_BUFFERS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_HSGETSHADERRESOURCES_VIEWS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_HSSETSAMPLERS_SAMPLERS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_HSGETCONSTANTBUFFERS_BUFFERS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_HSGETSHADERRESOURCES_VIEWS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_HSGETSAMPLERS_SAMPLERS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_HSGETCONSTANTBUFFERS_BUFFERS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_DSSETSHADERRESOURCES_HAZARD equ ( D3D11_MESSAGE_ID_DEVICE_HSGETSAMPLERS_SAMPLERS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_DSSETCONSTANTBUFFERS_HAZARD equ ( D3D11_MESSAGE_ID_DEVICE_DSSETSHADERRESOURCES_HAZARD + 1 )
D3D11_MESSAGE_ID_DSSETSHADERRESOURCES_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_DEVICE_DSSETCONSTANTBUFFERS_HAZARD + 1 )
D3D11_MESSAGE_ID_DSSETCONSTANTBUFFERS_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_DSSETSHADERRESOURCES_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_CREATEDOMAINSHADER_INVALIDCALL equ ( D3D11_MESSAGE_ID_DSSETCONSTANTBUFFERS_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_CREATEDOMAINSHADER_OUTOFMEMORY equ ( D3D11_MESSAGE_ID_CREATEDOMAINSHADER_INVALIDCALL + 1 )
D3D11_MESSAGE_ID_CREATEDOMAINSHADER_INVALIDSHADERBYTECODE equ ( D3D11_MESSAGE_ID_CREATEDOMAINSHADER_OUTOFMEMORY + 1 )
D3D11_MESSAGE_ID_CREATEDOMAINSHADER_INVALIDSHADERTYPE equ ( D3D11_MESSAGE_ID_CREATEDOMAINSHADER_INVALIDSHADERBYTECODE + 1 )
D3D11_MESSAGE_ID_CREATEDOMAINSHADER_INVALIDCLASSLINKAGE equ ( D3D11_MESSAGE_ID_CREATEDOMAINSHADER_INVALIDSHADERTYPE + 1 )
D3D11_MESSAGE_ID_DEVICE_DSSETSHADERRESOURCES_VIEWS_EMPTY equ ( D3D11_MESSAGE_ID_CREATEDOMAINSHADER_INVALIDCLASSLINKAGE + 1 )
D3D11_MESSAGE_ID_DSSETCONSTANTBUFFERS_INVALIDBUFFER equ ( D3D11_MESSAGE_ID_DEVICE_DSSETSHADERRESOURCES_VIEWS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_DSSETCONSTANTBUFFERS_BUFFERS_EMPTY equ ( D3D11_MESSAGE_ID_DSSETCONSTANTBUFFERS_INVALIDBUFFER + 1 )
D3D11_MESSAGE_ID_DEVICE_DSSETSAMPLERS_SAMPLERS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_DSSETCONSTANTBUFFERS_BUFFERS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_DSGETSHADERRESOURCES_VIEWS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_DSSETSAMPLERS_SAMPLERS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_DSGETCONSTANTBUFFERS_BUFFERS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_DSGETSHADERRESOURCES_VIEWS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_DSGETSAMPLERS_SAMPLERS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_DSGETCONSTANTBUFFERS_BUFFERS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_HS_XOR_DS_MISMATCH equ ( D3D11_MESSAGE_ID_DEVICE_DSGETSAMPLERS_SAMPLERS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEFERRED_CONTEXT_REMOVAL_PROCESS_AT_FAULT equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_HS_XOR_DS_MISMATCH + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAWINDIRECT_INVALID_ARG_BUFFER equ ( D3D11_MESSAGE_ID_DEFERRED_CONTEXT_REMOVAL_PROCESS_AT_FAULT + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAWINDIRECT_OFFSET_UNALIGNED equ ( D3D11_MESSAGE_ID_DEVICE_DRAWINDIRECT_INVALID_ARG_BUFFER + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAWINDIRECT_OFFSET_OVERFLOW equ ( D3D11_MESSAGE_ID_DEVICE_DRAWINDIRECT_OFFSET_UNALIGNED + 1 )
D3D11_MESSAGE_ID_RESOURCE_MAP_INVALIDMAPTYPE equ ( D3D11_MESSAGE_ID_DEVICE_DRAWINDIRECT_OFFSET_OVERFLOW + 1 )
D3D11_MESSAGE_ID_RESOURCE_MAP_INVALIDSUBRESOURCE equ ( D3D11_MESSAGE_ID_RESOURCE_MAP_INVALIDMAPTYPE + 1 )
D3D11_MESSAGE_ID_RESOURCE_MAP_INVALIDFLAGS equ ( D3D11_MESSAGE_ID_RESOURCE_MAP_INVALIDSUBRESOURCE + 1 )
D3D11_MESSAGE_ID_RESOURCE_MAP_ALREADYMAPPED equ ( D3D11_MESSAGE_ID_RESOURCE_MAP_INVALIDFLAGS + 1 )
D3D11_MESSAGE_ID_RESOURCE_MAP_DEVICEREMOVED_RETURN equ ( D3D11_MESSAGE_ID_RESOURCE_MAP_ALREADYMAPPED + 1 )
D3D11_MESSAGE_ID_RESOURCE_MAP_OUTOFMEMORY_RETURN equ ( D3D11_MESSAGE_ID_RESOURCE_MAP_DEVICEREMOVED_RETURN + 1 )
D3D11_MESSAGE_ID_RESOURCE_MAP_WITHOUT_INITIAL_DISCARD equ ( D3D11_MESSAGE_ID_RESOURCE_MAP_OUTOFMEMORY_RETURN + 1 )
D3D11_MESSAGE_ID_RESOURCE_UNMAP_INVALIDSUBRESOURCE equ ( D3D11_MESSAGE_ID_RESOURCE_MAP_WITHOUT_INITIAL_DISCARD + 1 )
D3D11_MESSAGE_ID_RESOURCE_UNMAP_NOTMAPPED equ ( D3D11_MESSAGE_ID_RESOURCE_UNMAP_INVALIDSUBRESOURCE + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_RASTERIZING_CONTROL_POINTS equ ( D3D11_MESSAGE_ID_RESOURCE_UNMAP_NOTMAPPED + 1 )
D3D11_MESSAGE_ID_DEVICE_IASETPRIMITIVETOPOLOGY_TOPOLOGY_UNSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_RASTERIZING_CONTROL_POINTS + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_HS_DS_SIGNATURE_MISMATCH equ ( D3D11_MESSAGE_ID_DEVICE_IASETPRIMITIVETOPOLOGY_TOPOLOGY_UNSUPPORTED + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_HULL_SHADER_INPUT_TOPOLOGY_MISMATCH equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_HS_DS_SIGNATURE_MISMATCH + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_HS_DS_CONTROL_POINT_COUNT_MISMATCH equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_HULL_SHADER_INPUT_TOPOLOGY_MISMATCH + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_HS_DS_TESSELLATOR_DOMAIN_MISMATCH equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_HS_DS_CONTROL_POINT_COUNT_MISMATCH + 1 )
D3D11_MESSAGE_ID_CREATE_CONTEXT equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_HS_DS_TESSELLATOR_DOMAIN_MISMATCH + 1 )
D3D11_MESSAGE_ID_LIVE_CONTEXT equ ( D3D11_MESSAGE_ID_CREATE_CONTEXT + 1 )
D3D11_MESSAGE_ID_DESTROY_CONTEXT equ ( D3D11_MESSAGE_ID_LIVE_CONTEXT + 1 )
D3D11_MESSAGE_ID_CREATE_BUFFER equ ( D3D11_MESSAGE_ID_DESTROY_CONTEXT + 1 )
D3D11_MESSAGE_ID_LIVE_BUFFER equ ( D3D11_MESSAGE_ID_CREATE_BUFFER + 1 )
D3D11_MESSAGE_ID_DESTROY_BUFFER equ ( D3D11_MESSAGE_ID_LIVE_BUFFER + 1 )
D3D11_MESSAGE_ID_CREATE_TEXTURE1D equ ( D3D11_MESSAGE_ID_DESTROY_BUFFER + 1 )
D3D11_MESSAGE_ID_LIVE_TEXTURE1D equ ( D3D11_MESSAGE_ID_CREATE_TEXTURE1D + 1 )
D3D11_MESSAGE_ID_DESTROY_TEXTURE1D equ ( D3D11_MESSAGE_ID_LIVE_TEXTURE1D + 1 )
D3D11_MESSAGE_ID_CREATE_TEXTURE2D equ ( D3D11_MESSAGE_ID_DESTROY_TEXTURE1D + 1 )
D3D11_MESSAGE_ID_LIVE_TEXTURE2D equ ( D3D11_MESSAGE_ID_CREATE_TEXTURE2D + 1 )
D3D11_MESSAGE_ID_DESTROY_TEXTURE2D equ ( D3D11_MESSAGE_ID_LIVE_TEXTURE2D + 1 )
D3D11_MESSAGE_ID_CREATE_TEXTURE3D equ ( D3D11_MESSAGE_ID_DESTROY_TEXTURE2D + 1 )
D3D11_MESSAGE_ID_LIVE_TEXTURE3D equ ( D3D11_MESSAGE_ID_CREATE_TEXTURE3D + 1 )
D3D11_MESSAGE_ID_DESTROY_TEXTURE3D equ ( D3D11_MESSAGE_ID_LIVE_TEXTURE3D + 1 )
D3D11_MESSAGE_ID_CREATE_SHADERRESOURCEVIEW equ ( D3D11_MESSAGE_ID_DESTROY_TEXTURE3D + 1 )
D3D11_MESSAGE_ID_LIVE_SHADERRESOURCEVIEW equ ( D3D11_MESSAGE_ID_CREATE_SHADERRESOURCEVIEW + 1 )
D3D11_MESSAGE_ID_DESTROY_SHADERRESOURCEVIEW equ ( D3D11_MESSAGE_ID_LIVE_SHADERRESOURCEVIEW + 1 )
D3D11_MESSAGE_ID_CREATE_RENDERTARGETVIEW equ ( D3D11_MESSAGE_ID_DESTROY_SHADERRESOURCEVIEW + 1 )
D3D11_MESSAGE_ID_LIVE_RENDERTARGETVIEW equ ( D3D11_MESSAGE_ID_CREATE_RENDERTARGETVIEW + 1 )
D3D11_MESSAGE_ID_DESTROY_RENDERTARGETVIEW equ ( D3D11_MESSAGE_ID_LIVE_RENDERTARGETVIEW + 1 )
D3D11_MESSAGE_ID_CREATE_DEPTHSTENCILVIEW equ ( D3D11_MESSAGE_ID_DESTROY_RENDERTARGETVIEW + 1 )
D3D11_MESSAGE_ID_LIVE_DEPTHSTENCILVIEW equ ( D3D11_MESSAGE_ID_CREATE_DEPTHSTENCILVIEW + 1 )
D3D11_MESSAGE_ID_DESTROY_DEPTHSTENCILVIEW equ ( D3D11_MESSAGE_ID_LIVE_DEPTHSTENCILVIEW + 1 )
D3D11_MESSAGE_ID_CREATE_VERTEXSHADER equ ( D3D11_MESSAGE_ID_DESTROY_DEPTHSTENCILVIEW + 1 )
D3D11_MESSAGE_ID_LIVE_VERTEXSHADER equ ( D3D11_MESSAGE_ID_CREATE_VERTEXSHADER + 1 )
D3D11_MESSAGE_ID_DESTROY_VERTEXSHADER equ ( D3D11_MESSAGE_ID_LIVE_VERTEXSHADER + 1 )
D3D11_MESSAGE_ID_CREATE_HULLSHADER equ ( D3D11_MESSAGE_ID_DESTROY_VERTEXSHADER + 1 )
D3D11_MESSAGE_ID_LIVE_HULLSHADER equ ( D3D11_MESSAGE_ID_CREATE_HULLSHADER + 1 )
D3D11_MESSAGE_ID_DESTROY_HULLSHADER equ ( D3D11_MESSAGE_ID_LIVE_HULLSHADER + 1 )
D3D11_MESSAGE_ID_CREATE_DOMAINSHADER equ ( D3D11_MESSAGE_ID_DESTROY_HULLSHADER + 1 )
D3D11_MESSAGE_ID_LIVE_DOMAINSHADER equ ( D3D11_MESSAGE_ID_CREATE_DOMAINSHADER + 1 )
D3D11_MESSAGE_ID_DESTROY_DOMAINSHADER equ ( D3D11_MESSAGE_ID_LIVE_DOMAINSHADER + 1 )
D3D11_MESSAGE_ID_CREATE_GEOMETRYSHADER equ ( D3D11_MESSAGE_ID_DESTROY_DOMAINSHADER + 1 )
D3D11_MESSAGE_ID_LIVE_GEOMETRYSHADER equ ( D3D11_MESSAGE_ID_CREATE_GEOMETRYSHADER + 1 )
D3D11_MESSAGE_ID_DESTROY_GEOMETRYSHADER equ ( D3D11_MESSAGE_ID_LIVE_GEOMETRYSHADER + 1 )
D3D11_MESSAGE_ID_CREATE_PIXELSHADER equ ( D3D11_MESSAGE_ID_DESTROY_GEOMETRYSHADER + 1 )
D3D11_MESSAGE_ID_LIVE_PIXELSHADER equ ( D3D11_MESSAGE_ID_CREATE_PIXELSHADER + 1 )
D3D11_MESSAGE_ID_DESTROY_PIXELSHADER equ ( D3D11_MESSAGE_ID_LIVE_PIXELSHADER + 1 )
D3D11_MESSAGE_ID_CREATE_INPUTLAYOUT equ ( D3D11_MESSAGE_ID_DESTROY_PIXELSHADER + 1 )
D3D11_MESSAGE_ID_LIVE_INPUTLAYOUT equ ( D3D11_MESSAGE_ID_CREATE_INPUTLAYOUT + 1 )
D3D11_MESSAGE_ID_DESTROY_INPUTLAYOUT equ ( D3D11_MESSAGE_ID_LIVE_INPUTLAYOUT + 1 )
D3D11_MESSAGE_ID_CREATE_SAMPLER equ ( D3D11_MESSAGE_ID_DESTROY_INPUTLAYOUT + 1 )
D3D11_MESSAGE_ID_LIVE_SAMPLER equ ( D3D11_MESSAGE_ID_CREATE_SAMPLER + 1 )
D3D11_MESSAGE_ID_DESTROY_SAMPLER equ ( D3D11_MESSAGE_ID_LIVE_SAMPLER + 1 )
D3D11_MESSAGE_ID_CREATE_BLENDSTATE equ ( D3D11_MESSAGE_ID_DESTROY_SAMPLER + 1 )
D3D11_MESSAGE_ID_LIVE_BLENDSTATE equ ( D3D11_MESSAGE_ID_CREATE_BLENDSTATE + 1 )
D3D11_MESSAGE_ID_DESTROY_BLENDSTATE equ ( D3D11_MESSAGE_ID_LIVE_BLENDSTATE + 1 )
D3D11_MESSAGE_ID_CREATE_DEPTHSTENCILSTATE equ ( D3D11_MESSAGE_ID_DESTROY_BLENDSTATE + 1 )
D3D11_MESSAGE_ID_LIVE_DEPTHSTENCILSTATE equ ( D3D11_MESSAGE_ID_CREATE_DEPTHSTENCILSTATE + 1 )
D3D11_MESSAGE_ID_DESTROY_DEPTHSTENCILSTATE equ ( D3D11_MESSAGE_ID_LIVE_DEPTHSTENCILSTATE + 1 )
D3D11_MESSAGE_ID_CREATE_RASTERIZERSTATE equ ( D3D11_MESSAGE_ID_DESTROY_DEPTHSTENCILSTATE + 1 )
D3D11_MESSAGE_ID_LIVE_RASTERIZERSTATE equ ( D3D11_MESSAGE_ID_CREATE_RASTERIZERSTATE + 1 )
D3D11_MESSAGE_ID_DESTROY_RASTERIZERSTATE equ ( D3D11_MESSAGE_ID_LIVE_RASTERIZERSTATE + 1 )
D3D11_MESSAGE_ID_CREATE_QUERY equ ( D3D11_MESSAGE_ID_DESTROY_RASTERIZERSTATE + 1 )
D3D11_MESSAGE_ID_LIVE_QUERY equ ( D3D11_MESSAGE_ID_CREATE_QUERY + 1 )
D3D11_MESSAGE_ID_DESTROY_QUERY equ ( D3D11_MESSAGE_ID_LIVE_QUERY + 1 )
D3D11_MESSAGE_ID_CREATE_PREDICATE equ ( D3D11_MESSAGE_ID_DESTROY_QUERY + 1 )
D3D11_MESSAGE_ID_LIVE_PREDICATE equ ( D3D11_MESSAGE_ID_CREATE_PREDICATE + 1 )
D3D11_MESSAGE_ID_DESTROY_PREDICATE equ ( D3D11_MESSAGE_ID_LIVE_PREDICATE + 1 )
D3D11_MESSAGE_ID_CREATE_COUNTER equ ( D3D11_MESSAGE_ID_DESTROY_PREDICATE + 1 )
D3D11_MESSAGE_ID_LIVE_COUNTER equ ( D3D11_MESSAGE_ID_CREATE_COUNTER + 1 )
D3D11_MESSAGE_ID_DESTROY_COUNTER equ ( D3D11_MESSAGE_ID_LIVE_COUNTER + 1 )
D3D11_MESSAGE_ID_CREATE_COMMANDLIST equ ( D3D11_MESSAGE_ID_DESTROY_COUNTER + 1 )
D3D11_MESSAGE_ID_LIVE_COMMANDLIST equ ( D3D11_MESSAGE_ID_CREATE_COMMANDLIST + 1 )
D3D11_MESSAGE_ID_DESTROY_COMMANDLIST equ ( D3D11_MESSAGE_ID_LIVE_COMMANDLIST + 1 )
D3D11_MESSAGE_ID_CREATE_CLASSINSTANCE equ ( D3D11_MESSAGE_ID_DESTROY_COMMANDLIST + 1 )
D3D11_MESSAGE_ID_LIVE_CLASSINSTANCE equ ( D3D11_MESSAGE_ID_CREATE_CLASSINSTANCE + 1 )
D3D11_MESSAGE_ID_DESTROY_CLASSINSTANCE equ ( D3D11_MESSAGE_ID_LIVE_CLASSINSTANCE + 1 )
D3D11_MESSAGE_ID_CREATE_CLASSLINKAGE equ ( D3D11_MESSAGE_ID_DESTROY_CLASSINSTANCE + 1 )
D3D11_MESSAGE_ID_LIVE_CLASSLINKAGE equ ( D3D11_MESSAGE_ID_CREATE_CLASSLINKAGE + 1 )
D3D11_MESSAGE_ID_DESTROY_CLASSLINKAGE equ ( D3D11_MESSAGE_ID_LIVE_CLASSLINKAGE + 1 )
D3D11_MESSAGE_ID_LIVE_DEVICE equ ( D3D11_MESSAGE_ID_DESTROY_CLASSLINKAGE + 1 )
D3D11_MESSAGE_ID_LIVE_OBJECT_SUMMARY equ ( D3D11_MESSAGE_ID_LIVE_DEVICE + 1 )
D3D11_MESSAGE_ID_CREATE_COMPUTESHADER equ ( D3D11_MESSAGE_ID_LIVE_OBJECT_SUMMARY + 1 )
D3D11_MESSAGE_ID_LIVE_COMPUTESHADER equ ( D3D11_MESSAGE_ID_CREATE_COMPUTESHADER + 1 )
D3D11_MESSAGE_ID_DESTROY_COMPUTESHADER equ ( D3D11_MESSAGE_ID_LIVE_COMPUTESHADER + 1 )
D3D11_MESSAGE_ID_CREATE_UNORDEREDACCESSVIEW equ ( D3D11_MESSAGE_ID_DESTROY_COMPUTESHADER + 1 )
D3D11_MESSAGE_ID_LIVE_UNORDEREDACCESSVIEW equ ( D3D11_MESSAGE_ID_CREATE_UNORDEREDACCESSVIEW + 1 )
D3D11_MESSAGE_ID_DESTROY_UNORDEREDACCESSVIEW equ ( D3D11_MESSAGE_ID_LIVE_UNORDEREDACCESSVIEW + 1 )
D3D11_MESSAGE_ID_DEVICE_SETSHADER_INTERFACES_FEATURELEVEL equ ( D3D11_MESSAGE_ID_DESTROY_UNORDEREDACCESSVIEW + 1 )
D3D11_MESSAGE_ID_DEVICE_SETSHADER_INTERFACE_COUNT_MISMATCH equ ( D3D11_MESSAGE_ID_DEVICE_SETSHADER_INTERFACES_FEATURELEVEL + 1 )
D3D11_MESSAGE_ID_DEVICE_SETSHADER_INVALID_INSTANCE equ ( D3D11_MESSAGE_ID_DEVICE_SETSHADER_INTERFACE_COUNT_MISMATCH + 1 )
D3D11_MESSAGE_ID_DEVICE_SETSHADER_INVALID_INSTANCE_INDEX equ ( D3D11_MESSAGE_ID_DEVICE_SETSHADER_INVALID_INSTANCE + 1 )
D3D11_MESSAGE_ID_DEVICE_SETSHADER_INVALID_INSTANCE_TYPE equ ( D3D11_MESSAGE_ID_DEVICE_SETSHADER_INVALID_INSTANCE_INDEX + 1 )
D3D11_MESSAGE_ID_DEVICE_SETSHADER_INVALID_INSTANCE_DATA equ ( D3D11_MESSAGE_ID_DEVICE_SETSHADER_INVALID_INSTANCE_TYPE + 1 )
D3D11_MESSAGE_ID_DEVICE_SETSHADER_UNBOUND_INSTANCE_DATA equ ( D3D11_MESSAGE_ID_DEVICE_SETSHADER_INVALID_INSTANCE_DATA + 1 )
D3D11_MESSAGE_ID_DEVICE_SETSHADER_INSTANCE_DATA_BINDINGS equ ( D3D11_MESSAGE_ID_DEVICE_SETSHADER_UNBOUND_INSTANCE_DATA + 1 )
D3D11_MESSAGE_ID_DEVICE_CREATESHADER_CLASSLINKAGE_FULL equ ( D3D11_MESSAGE_ID_DEVICE_SETSHADER_INSTANCE_DATA_BINDINGS + 1 )
D3D11_MESSAGE_ID_DEVICE_CHECKFEATURESUPPORT_UNRECOGNIZED_FEATURE equ ( D3D11_MESSAGE_ID_DEVICE_CREATESHADER_CLASSLINKAGE_FULL + 1 )
D3D11_MESSAGE_ID_DEVICE_CHECKFEATURESUPPORT_MISMATCHED_DATA_SIZE equ ( D3D11_MESSAGE_ID_DEVICE_CHECKFEATURESUPPORT_UNRECOGNIZED_FEATURE + 1 )
D3D11_MESSAGE_ID_DEVICE_CHECKFEATURESUPPORT_INVALIDARG_RETURN equ ( D3D11_MESSAGE_ID_DEVICE_CHECKFEATURESUPPORT_MISMATCHED_DATA_SIZE + 1 )
D3D11_MESSAGE_ID_DEVICE_CSSETSHADERRESOURCES_HAZARD equ ( D3D11_MESSAGE_ID_DEVICE_CHECKFEATURESUPPORT_INVALIDARG_RETURN + 1 )
D3D11_MESSAGE_ID_DEVICE_CSSETCONSTANTBUFFERS_HAZARD equ ( D3D11_MESSAGE_ID_DEVICE_CSSETSHADERRESOURCES_HAZARD + 1 )
D3D11_MESSAGE_ID_CSSETSHADERRESOURCES_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_DEVICE_CSSETCONSTANTBUFFERS_HAZARD + 1 )
D3D11_MESSAGE_ID_CSSETCONSTANTBUFFERS_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_CSSETSHADERRESOURCES_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_CREATECOMPUTESHADER_INVALIDCALL equ ( D3D11_MESSAGE_ID_CSSETCONSTANTBUFFERS_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_CREATECOMPUTESHADER_OUTOFMEMORY equ ( D3D11_MESSAGE_ID_CREATECOMPUTESHADER_INVALIDCALL + 1 )
D3D11_MESSAGE_ID_CREATECOMPUTESHADER_INVALIDSHADERBYTECODE equ ( D3D11_MESSAGE_ID_CREATECOMPUTESHADER_OUTOFMEMORY + 1 )
D3D11_MESSAGE_ID_CREATECOMPUTESHADER_INVALIDSHADERTYPE equ ( D3D11_MESSAGE_ID_CREATECOMPUTESHADER_INVALIDSHADERBYTECODE + 1 )
D3D11_MESSAGE_ID_CREATECOMPUTESHADER_INVALIDCLASSLINKAGE equ ( D3D11_MESSAGE_ID_CREATECOMPUTESHADER_INVALIDSHADERTYPE + 1 )
D3D11_MESSAGE_ID_DEVICE_CSSETSHADERRESOURCES_VIEWS_EMPTY equ ( D3D11_MESSAGE_ID_CREATECOMPUTESHADER_INVALIDCLASSLINKAGE + 1 )
D3D11_MESSAGE_ID_CSSETCONSTANTBUFFERS_INVALIDBUFFER equ ( D3D11_MESSAGE_ID_DEVICE_CSSETSHADERRESOURCES_VIEWS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_CSSETCONSTANTBUFFERS_BUFFERS_EMPTY equ ( D3D11_MESSAGE_ID_CSSETCONSTANTBUFFERS_INVALIDBUFFER + 1 )
D3D11_MESSAGE_ID_DEVICE_CSSETSAMPLERS_SAMPLERS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_CSSETCONSTANTBUFFERS_BUFFERS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_CSGETSHADERRESOURCES_VIEWS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_CSSETSAMPLERS_SAMPLERS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_CSGETCONSTANTBUFFERS_BUFFERS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_CSGETSHADERRESOURCES_VIEWS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_CSGETSAMPLERS_SAMPLERS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_CSGETCONSTANTBUFFERS_BUFFERS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_CREATEVERTEXSHADER_DOUBLEFLOATOPSNOTSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_CSGETSAMPLERS_SAMPLERS_EMPTY + 1 )
D3D11_MESSAGE_ID_DEVICE_CREATEHULLSHADER_DOUBLEFLOATOPSNOTSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_CREATEVERTEXSHADER_DOUBLEFLOATOPSNOTSUPPORTED + 1 )
D3D11_MESSAGE_ID_DEVICE_CREATEDOMAINSHADER_DOUBLEFLOATOPSNOTSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_CREATEHULLSHADER_DOUBLEFLOATOPSNOTSUPPORTED + 1 )
D3D11_MESSAGE_ID_DEVICE_CREATEGEOMETRYSHADER_DOUBLEFLOATOPSNOTSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_CREATEDOMAINSHADER_DOUBLEFLOATOPSNOTSUPPORTED + 1 )
D3D11_MESSAGE_ID_DEVICE_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_DOUBLEFLOATOPSNOTSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_CREATEGEOMETRYSHADER_DOUBLEFLOATOPSNOTSUPPORTED + 1 )
D3D11_MESSAGE_ID_DEVICE_CREATEPIXELSHADER_DOUBLEFLOATOPSNOTSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_CREATEGEOMETRYSHADERWITHSTREAMOUTPUT_DOUBLEFLOATOPSNOTSUPPORTED + 1 )
D3D11_MESSAGE_ID_DEVICE_CREATECOMPUTESHADER_DOUBLEFLOATOPSNOTSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_CREATEPIXELSHADER_DOUBLEFLOATOPSNOTSUPPORTED + 1 )
D3D11_MESSAGE_ID_CREATEBUFFER_INVALIDSTRUCTURESTRIDE equ ( D3D11_MESSAGE_ID_DEVICE_CREATECOMPUTESHADER_DOUBLEFLOATOPSNOTSUPPORTED + 1 )
D3D11_MESSAGE_ID_CREATESHADERRESOURCEVIEW_INVALIDFLAGS equ ( D3D11_MESSAGE_ID_CREATEBUFFER_INVALIDSTRUCTURESTRIDE + 1 )
D3D11_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_INVALIDRESOURCE equ ( D3D11_MESSAGE_ID_CREATESHADERRESOURCEVIEW_INVALIDFLAGS + 1 )
D3D11_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_INVALIDDESC equ ( D3D11_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_INVALIDRESOURCE + 1 )
D3D11_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_INVALIDFORMAT equ ( D3D11_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_INVALIDDESC + 1 )
D3D11_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_INVALIDDIMENSIONS equ ( D3D11_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_INVALIDFORMAT + 1 )
D3D11_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_UNRECOGNIZEDFORMAT equ ( D3D11_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_INVALIDDIMENSIONS + 1 )
D3D11_MESSAGE_ID_DEVICE_OMSETRENDERTARGETSANDUNORDEREDACCESSVIEWS_HAZARD equ ( D3D11_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_UNRECOGNIZEDFORMAT + 1 )
D3D11_MESSAGE_ID_DEVICE_OMSETRENDERTARGETSANDUNORDEREDACCESSVIEWS_OVERLAPPING_OLD_SLOTS equ ( D3D11_MESSAGE_ID_DEVICE_OMSETRENDERTARGETSANDUNORDEREDACCESSVIEWS_HAZARD + 1 )
D3D11_MESSAGE_ID_DEVICE_OMSETRENDERTARGETSANDUNORDEREDACCESSVIEWS_NO_OP equ ( D3D11_MESSAGE_ID_DEVICE_OMSETRENDERTARGETSANDUNORDEREDACCESSVIEWS_OVERLAPPING_OLD_SLOTS + 1 )
D3D11_MESSAGE_ID_CSSETUNORDEREDACCESSVIEWS_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_DEVICE_OMSETRENDERTARGETSANDUNORDEREDACCESSVIEWS_NO_OP + 1 )
D3D11_MESSAGE_ID_PSSETUNORDEREDACCESSVIEWS_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_CSSETUNORDEREDACCESSVIEWS_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_INVALIDARG_RETURN equ ( D3D11_MESSAGE_ID_PSSETUNORDEREDACCESSVIEWS_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_OUTOFMEMORY_RETURN equ ( D3D11_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_INVALIDARG_RETURN + 1 )
D3D11_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_TOOMANYOBJECTS equ ( D3D11_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_OUTOFMEMORY_RETURN + 1 )
D3D11_MESSAGE_ID_DEVICE_CSSETUNORDEREDACCESSVIEWS_HAZARD equ ( D3D11_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_TOOMANYOBJECTS + 1 )
D3D11_MESSAGE_ID_CLEARUNORDEREDACCESSVIEW_DENORMFLUSH equ ( D3D11_MESSAGE_ID_DEVICE_CSSETUNORDEREDACCESSVIEWS_HAZARD + 1 )
D3D11_MESSAGE_ID_DEVICE_CSSETUNORDEREDACCESSS_VIEWS_EMPTY equ ( D3D11_MESSAGE_ID_CLEARUNORDEREDACCESSVIEW_DENORMFLUSH + 1 )
D3D11_MESSAGE_ID_DEVICE_CSGETUNORDEREDACCESSS_VIEWS_EMPTY equ ( D3D11_MESSAGE_ID_DEVICE_CSSETUNORDEREDACCESSS_VIEWS_EMPTY + 1 )
D3D11_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_INVALIDFLAGS equ ( D3D11_MESSAGE_ID_DEVICE_CSGETUNORDEREDACCESSS_VIEWS_EMPTY + 1 )
D3D11_MESSAGE_ID_CREATESHADERRESESOURCEVIEW_TOOMANYOBJECTS equ ( D3D11_MESSAGE_ID_CREATEUNORDEREDACCESSVIEW_INVALIDFLAGS + 1 )
D3D11_MESSAGE_ID_DEVICE_DISPATCHINDIRECT_INVALID_ARG_BUFFER equ ( D3D11_MESSAGE_ID_CREATESHADERRESESOURCEVIEW_TOOMANYOBJECTS + 1 )
D3D11_MESSAGE_ID_DEVICE_DISPATCHINDIRECT_OFFSET_UNALIGNED equ ( D3D11_MESSAGE_ID_DEVICE_DISPATCHINDIRECT_INVALID_ARG_BUFFER + 1 )
D3D11_MESSAGE_ID_DEVICE_DISPATCHINDIRECT_OFFSET_OVERFLOW equ ( D3D11_MESSAGE_ID_DEVICE_DISPATCHINDIRECT_OFFSET_UNALIGNED + 1 )
D3D11_MESSAGE_ID_DEVICE_SETRESOURCEMINLOD_INVALIDCONTEXT equ ( D3D11_MESSAGE_ID_DEVICE_DISPATCHINDIRECT_OFFSET_OVERFLOW + 1 )
D3D11_MESSAGE_ID_DEVICE_SETRESOURCEMINLOD_INVALIDRESOURCE equ ( D3D11_MESSAGE_ID_DEVICE_SETRESOURCEMINLOD_INVALIDCONTEXT + 1 )
D3D11_MESSAGE_ID_DEVICE_SETRESOURCEMINLOD_INVALIDMINLOD equ ( D3D11_MESSAGE_ID_DEVICE_SETRESOURCEMINLOD_INVALIDRESOURCE + 1 )
D3D11_MESSAGE_ID_DEVICE_GETRESOURCEMINLOD_INVALIDCONTEXT equ ( D3D11_MESSAGE_ID_DEVICE_SETRESOURCEMINLOD_INVALIDMINLOD + 1 )
D3D11_MESSAGE_ID_DEVICE_GETRESOURCEMINLOD_INVALIDRESOURCE equ ( D3D11_MESSAGE_ID_DEVICE_GETRESOURCEMINLOD_INVALIDCONTEXT + 1 )
D3D11_MESSAGE_ID_OMSETDEPTHSTENCIL_UNBINDDELETINGOBJECT equ ( D3D11_MESSAGE_ID_DEVICE_GETRESOURCEMINLOD_INVALIDRESOURCE + 1 )
D3D11_MESSAGE_ID_CLEARDEPTHSTENCILVIEW_DEPTH_READONLY equ ( D3D11_MESSAGE_ID_OMSETDEPTHSTENCIL_UNBINDDELETINGOBJECT + 1 )
D3D11_MESSAGE_ID_CLEARDEPTHSTENCILVIEW_STENCIL_READONLY equ ( D3D11_MESSAGE_ID_CLEARDEPTHSTENCILVIEW_DEPTH_READONLY + 1 )
D3D11_MESSAGE_ID_CHECKFEATURESUPPORT_FORMAT_DEPRECATED equ ( D3D11_MESSAGE_ID_CLEARDEPTHSTENCILVIEW_STENCIL_READONLY + 1 )
D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_RETURN_TYPE_MISMATCH equ ( D3D11_MESSAGE_ID_CHECKFEATURESUPPORT_FORMAT_DEPRECATED + 1 )
D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_NOT_SET equ ( D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_RETURN_TYPE_MISMATCH + 1 )
D3D11_MESSAGE_ID_DEVICE_DRAW_UNORDEREDACCESSVIEW_RENDERTARGETVIEW_OVERLAP equ ( D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_NOT_SET + 1 )
D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_DIMENSION_MISMATCH equ ( D3D11_MESSAGE_ID_DEVICE_DRAW_UNORDEREDACCESSVIEW_RENDERTARGETVIEW_OVERLAP + 1 )
D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_APPEND_UNSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_DIMENSION_MISMATCH + 1 )
D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_ATOMICS_UNSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_APPEND_UNSUPPORTED + 1 )
D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_STRUCTURE_STRIDE_MISMATCH equ ( D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_ATOMICS_UNSUPPORTED + 1 )
D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_BUFFER_TYPE_MISMATCH equ ( D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_STRUCTURE_STRIDE_MISMATCH + 1 )
D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_RAW_UNSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_BUFFER_TYPE_MISMATCH + 1 )
D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_FORMAT_LD_UNSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_RAW_UNSUPPORTED + 1 )
D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_FORMAT_STORE_UNSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_FORMAT_LD_UNSUPPORTED + 1 )
D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_ATOMIC_ADD_UNSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_FORMAT_STORE_UNSUPPORTED + 1 )
D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_ATOMIC_BITWISE_OPS_UNSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_ATOMIC_ADD_UNSUPPORTED + 1 )
D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_ATOMIC_CMPSTORE_CMPEXCHANGE_UNSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_ATOMIC_BITWISE_OPS_UNSUPPORTED + 1 )
D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_ATOMIC_EXCHANGE_UNSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_ATOMIC_CMPSTORE_CMPEXCHANGE_UNSUPPORTED + 1 )
D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_ATOMIC_SIGNED_MINMAX_UNSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_ATOMIC_EXCHANGE_UNSUPPORTED + 1 )
D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_ATOMIC_UNSIGNED_MINMAX_UNSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_ATOMIC_SIGNED_MINMAX_UNSUPPORTED + 1 )
D3D11_MESSAGE_ID_DEVICE_DISPATCH_BOUND_RESOURCE_MAPPED equ ( D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_ATOMIC_UNSIGNED_MINMAX_UNSUPPORTED + 1 )
D3D11_MESSAGE_ID_DEVICE_DISPATCH_THREADGROUPCOUNT_OVERFLOW equ ( D3D11_MESSAGE_ID_DEVICE_DISPATCH_BOUND_RESOURCE_MAPPED + 1 )
D3D11_MESSAGE_ID_DEVICE_DISPATCH_THREADGROUPCOUNT_ZERO equ ( D3D11_MESSAGE_ID_DEVICE_DISPATCH_THREADGROUPCOUNT_OVERFLOW + 1 )
D3D11_MESSAGE_ID_DEVICE_SHADERRESOURCEVIEW_STRUCTURE_STRIDE_MISMATCH equ ( D3D11_MESSAGE_ID_DEVICE_DISPATCH_THREADGROUPCOUNT_ZERO + 1 )
D3D11_MESSAGE_ID_DEVICE_SHADERRESOURCEVIEW_BUFFER_TYPE_MISMATCH equ ( D3D11_MESSAGE_ID_DEVICE_SHADERRESOURCEVIEW_STRUCTURE_STRIDE_MISMATCH + 1 )
D3D11_MESSAGE_ID_DEVICE_SHADERRESOURCEVIEW_RAW_UNSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_SHADERRESOURCEVIEW_BUFFER_TYPE_MISMATCH + 1 )
D3D11_MESSAGE_ID_DEVICE_DISPATCH_UNSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_SHADERRESOURCEVIEW_RAW_UNSUPPORTED + 1 )
D3D11_MESSAGE_ID_DEVICE_DISPATCHINDIRECT_UNSUPPORTED equ ( D3D11_MESSAGE_ID_DEVICE_DISPATCH_UNSUPPORTED + 1 )
D3D11_MESSAGE_ID_COPYSTRUCTURECOUNT_INVALIDOFFSET equ ( D3D11_MESSAGE_ID_DEVICE_DISPATCHINDIRECT_UNSUPPORTED + 1 )
D3D11_MESSAGE_ID_COPYSTRUCTURECOUNT_LARGEOFFSET equ ( D3D11_MESSAGE_ID_COPYSTRUCTURECOUNT_INVALIDOFFSET + 1 )
D3D11_MESSAGE_ID_COPYSTRUCTURECOUNT_INVALIDDESTINATIONSTATE equ ( D3D11_MESSAGE_ID_COPYSTRUCTURECOUNT_LARGEOFFSET + 1 )
D3D11_MESSAGE_ID_COPYSTRUCTURECOUNT_INVALIDSOURCESTATE equ ( D3D11_MESSAGE_ID_COPYSTRUCTURECOUNT_INVALIDDESTINATIONSTATE + 1 )
D3D11_MESSAGE_ID_CHECKFORMATSUPPORT_FORMAT_NOT_SUPPORTED equ ( D3D11_MESSAGE_ID_COPYSTRUCTURECOUNT_INVALIDSOURCESTATE + 1 )
D3D11_MESSAGE_ID_DEVICE_CSSETUNORDEREDACCESSVIEWS_INVALIDVIEW equ ( D3D11_MESSAGE_ID_CHECKFORMATSUPPORT_FORMAT_NOT_SUPPORTED + 1 )
D3D11_MESSAGE_ID_DEVICE_CSSETUNORDEREDACCESSVIEWS_INVALIDOFFSET equ ( D3D11_MESSAGE_ID_DEVICE_CSSETUNORDEREDACCESSVIEWS_INVALIDVIEW + 1 )
D3D11_MESSAGE_ID_DEVICE_CSSETUNORDEREDACCESSVIEWS_TOOMANYVIEWS equ ( D3D11_MESSAGE_ID_DEVICE_CSSETUNORDEREDACCESSVIEWS_INVALIDOFFSET + 1 )
D3D11_MESSAGE_ID_CLEARUNORDEREDACCESSVIEWFLOAT_INVALIDFORMAT equ ( D3D11_MESSAGE_ID_DEVICE_CSSETUNORDEREDACCESSVIEWS_TOOMANYVIEWS + 1 )
D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_COUNTER_UNSUPPORTED equ ( D3D11_MESSAGE_ID_CLEARUNORDEREDACCESSVIEWFLOAT_INVALIDFORMAT + 1 )
D3D11_MESSAGE_ID_D3D11_MESSAGES_END equ ( D3D11_MESSAGE_ID_DEVICE_UNORDEREDACCESSVIEW_COUNTER_UNSUPPORTED + 1 )

D3D11_MESSAGE		STRUC
Category		D3D11_MESSAGE_CATEGORY ?
Severity		D3D11_MESSAGE_SEVERITY ?
ID			D3D11_MESSAGE_ID ?
pDescription		LPSTR ?
DescriptionByteLength	SIZE_T ?
D3D11_MESSAGE		ENDS

LPD3D11_MESSAGE_CATEGORY typedef ptr D3D11_MESSAGE_CATEGORY
LPD3D11_MESSAGE_SEVERITY typedef ptr D3D11_MESSAGE_SEVERITY
LPD3D11_MESSAGE_ID	 typedef ptr D3D11_MESSAGE_ID

D3D11_INFO_QUEUE_FILTER_DESC STRUC
NumCategories		UINT ?
pCategoryList		LPD3D11_MESSAGE_CATEGORY ?
NumSeverities		UINT ?
pSeverityList		LPD3D11_MESSAGE_SEVERITY ?
NumIDs			UINT ?
pIDList			LPD3D11_MESSAGE_ID ?
D3D11_INFO_QUEUE_FILTER_DESC ENDS

D3D11_INFO_QUEUE_FILTER STRUC
AllowList		D3D11_INFO_QUEUE_FILTER_DESC <>
DenyList		D3D11_INFO_QUEUE_FILTER_DESC <>
D3D11_INFO_QUEUE_FILTER ENDS

D3D11_INFO_QUEUE_DEFAULT_MESSAGE_COUNT_LIMIT equ 1024

ifndef __ID3D11InfoQueue_INTERFACE_DEFINED__
define __ID3D11InfoQueue_INTERFACE_DEFINED__

.comdef ID3D11InfoQueue : public IUnknown

    SetMessageCountLimit proc :UINT64
    ClearStoredMessages proc
    GetMessage		proc :UINT64
    GetNumMessagesAllowedByStorageFilter proc
    GetNumMessagesDeniedByStorageFilter proc
    GetNumStoredMessages proc
    GetNumStoredMessagesAllowedByRetrievalFilter proc
    GetNumMessagesDiscardedByMessageCountLimit proc
    GetMessageCountLimit proc
    AddStorageFilterEntries proc :ptr
    GetStorageFilter	proc
    ClearStorageFilter	proc
    PushEmptyStorageFilter proc
    PushCopyOfStorageFilter proc
    PushStorageFilter	proc :ptr
    PopStorageFilter	proc
    GetStorageFilterStackSize proc
    AddRetrievalFilterEntries proc :ptr
    GetRetrievalFilter	proc
    ClearRetrievalFilter proc
    PushEmptyRetrievalFilter proc
    PushCopyOfRetrievalFilter proc
    PushRetrievalFilter proc :ptr
    PopRetrievalFilter	proc
    GetRetrievalFilterStackSize proc
    AddMessage		proc :D3D11_MESSAGE_CATEGORY, :D3D11_MESSAGE_SEVERITY, :D3D11_MESSAGE_ID, :LPCSTR
    AddApplicationMessage proc :D3D11_MESSAGE_SEVERITY, :LPCSTR
    SetBreakOnCategory	proc :D3D11_MESSAGE_CATEGORY, :BOOL
    SetBreakOnSeverity	proc :D3D11_MESSAGE_SEVERITY, :BOOL
    SetBreakOnID	proc :D3D11_MESSAGE_ID, :BOOL
    GetBreakOnCategory	proc :D3D11_MESSAGE_CATEGORY
    GetBreakOnSeverity	proc :D3D11_MESSAGE_SEVERITY
    GetBreakOnID	proc :D3D11_MESSAGE_ID
    SetMuteDebugOutput	proc :BOOL
    GetMuteDebugOutput	proc
   .ends
endif

D3D11_REGKEY_PATH	equ __TEXT("Software\\Microsoft\\Direct3D")
D3D11_MUTE_DEBUG_OUTPUT equ __TEXT("MuteDebugOutput")
D3D11_ENABLE_BREAK_ON_MESSAGE equ __TEXT("EnableBreakOnMessage")
D3D11_INFOQUEUE_STORAGE_FILTER_OVERRIDE equ __TEXT("InfoQueueStorageFilterOverride")
D3D11_MUTE_CATEGORY	equ __TEXT("Mute_CATEGORY_%s")
D3D11_MUTE_SEVERITY	equ __TEXT("Mute_SEVERITY_%s")
D3D11_MUTE_ID_STRING	equ __TEXT("Mute_ID_%s")
D3D11_MUTE_ID_DECIMAL	equ __TEXT("Mute_ID_%d")
D3D11_UNMUTE_SEVERITY_INFO equ __TEXT("Unmute_SEVERITY_INFO")
D3D11_BREAKON_CATEGORY	equ __TEXT("BreakOn_CATEGORY_%s")
D3D11_BREAKON_SEVERITY	equ __TEXT("BreakOn_SEVERITY_%s")
D3D11_BREAKON_ID_STRING equ __TEXT("BreakOn_ID_%s")
D3D11_BREAKON_ID_DECIMAL equ __TEXT("BreakOn_ID_%d")
D3D11_APPSIZE_STRING	equ __TEXT("Size")
D3D11_APPNAME_STRING	equ __TEXT("Name")
DEFINE_GUID(IID_ID3D11Debug,0x79cf2233,0x7536,0x4948,0x9d,0x36,0x1e,0x46,0x92,0xdc,0x57,0x60);
DEFINE_GUID(IID_ID3D11SwitchToRef,0x1ef337e3,0x58e7,0x4f83,0xa6,0x92,0xdb,0x22,0x1f,0x5e,0xd4,0x7e);
DEFINE_GUID(IID_ID3D11InfoQueue,0x6543dbb6,0x1b48,0x42f5,0xab,0x82,0xe9,0x7e,0xc7,0x43,0x26,0xf6);

endif
