ifndef _D3D8CAPS_H
define _D3D8CAPS_H

ifndef DIRECT3D_VERSION
DIRECT3D_VERSION	equ 0x0800
endif

if(DIRECT3D_VERSION GE 0x0800)

if defined(_X86_) OR defined(_IA64_)
.pragma pack(push, 4)
endif

D3DCAPS8		STRUC
DeviceType		D3DDEVTYPE ?
AdapterOrdinal		UINT ?
Caps			dd ?
Caps2			dd ?
Caps3			dd ?
PresentationIntervals	dd ?
CursorCaps		dd ?
DevCaps			dd ?
PrimitiveMiscCaps	dd ?
RasterCaps		dd ?
ZCmpCaps		dd ?
SrcBlendCaps		dd ?
DestBlendCaps		dd ?
AlphaCmpCaps		dd ?
ShadeCaps		dd ?
TextureCaps		dd ?
TextureFilterCaps	dd ?
CubeTextureFilterCaps	dd ?
VolumeTextureFilterCaps dd ?
TextureAddressCaps	dd ?
VolumeTextureAddressCaps dd ?
LineCaps		dd ?
MaxTextureWidth		dd ?
MaxTextureHeight	dd ?
MaxVolumeExtent		dd ?
MaxTextureRepeat	dd ?
MaxTextureAspectRatio	dd ?
MaxAnisotropy		dd ?
MaxVertexW		real4 ?
GuardBandLeft		real4 ?
GuardBandTop		real4 ?
GuardBandRight		real4 ?
GuardBandBottom		real4 ?
ExtentsAdjust		real4 ?
StencilCaps		dd ?
FVFCaps			dd ?
TextureOpCaps		dd ?
MaxTextureBlendStages	dd ?
MaxSimultaneousTextures dd ?
VertexProcessingCaps	dd ?
MaxActiveLights		dd ?
MaxUserClipPlanes	dd ?
MaxVertexBlendMatrices	dd ?
MaxVertexBlendMatrixIndex dd ?
MaxPointSize		real4 ?
MaxPrimitiveCount	dd ?
MaxVertexIndex		dd ?
MaxStreams		dd ?
MaxStreamStride		dd ?
VertexShaderVersion	dd ?
MaxVertexShaderConst	dd ?
PixelShaderVersion	dd ?
MaxPixelShaderValue	real4 ?
D3DCAPS8		ENDS

D3DCAPS_READ_SCANLINE	equ 0x00020000
D3DCAPS2_NO2DDURING3DSCENE equ 0x00000002
D3DCAPS2_FULLSCREENGAMMA equ 0x00020000
D3DCAPS2_CANRENDERWINDOWED equ 0x00080000
D3DCAPS2_CANCALIBRATEGAMMA equ 0x00100000
D3DCAPS2_RESERVED	equ 0x02000000
D3DCAPS2_CANMANAGERESOURCE equ 0x10000000
D3DCAPS2_DYNAMICTEXTURES equ 0x20000000
D3DCAPS3_RESERVED	equ 0x8000001

D3DCAPS3_ALPHA_FULLSCREEN_FLIP_OR_DISCARD equ 0x00000020

D3DPRESENT_INTERVAL_DEFAULT equ 0x00000000
D3DPRESENT_INTERVAL_ONE equ 0x00000001
D3DPRESENT_INTERVAL_TWO equ 0x00000002
D3DPRESENT_INTERVAL_THREE equ 0x00000004
D3DPRESENT_INTERVAL_FOUR equ 0x00000008
D3DPRESENT_INTERVAL_IMMEDIATE equ 0x80000000

D3DCURSORCAPS_COLOR	equ 0x00000001
D3DCURSORCAPS_LOWRES	equ 0x00000002

D3DDEVCAPS_EXECUTESYSTEMMEMORY equ 0x00000010
D3DDEVCAPS_EXECUTEVIDEOMEMORY equ 0x00000020
D3DDEVCAPS_TLVERTEXSYSTEMMEMORY equ 0x00000040
D3DDEVCAPS_TLVERTEXVIDEOMEMORY equ 0x00000080
D3DDEVCAPS_TEXTURESYSTEMMEMORY equ 0x00000100
D3DDEVCAPS_TEXTUREVIDEOMEMORY equ 0x00000200
D3DDEVCAPS_DRAWPRIMTLVERTEX equ 0x00000400
D3DDEVCAPS_CANRENDERAFTERFLIP equ 0x00000800
D3DDEVCAPS_TEXTURENONLOCALVIDMEM equ 0x00001000
D3DDEVCAPS_DRAWPRIMITIVES2 equ 0x00002000
D3DDEVCAPS_SEPARATETEXTUREMEMORIES equ 0x00004000
D3DDEVCAPS_DRAWPRIMITIVES2EX equ 0x00008000
D3DDEVCAPS_HWTRANSFORMANDLIGHT equ 0x00010000
D3DDEVCAPS_CANBLTSYSTONONLOCAL equ 0x00020000
D3DDEVCAPS_HWRASTERIZATION equ 0x00080000
D3DDEVCAPS_PUREDEVICE	equ 0x00100000
D3DDEVCAPS_QUINTICRTPATCHES equ 0x00200000
D3DDEVCAPS_RTPATCHES	equ 0x00400000
D3DDEVCAPS_RTPATCHHANDLEZERO equ 0x00800000
D3DDEVCAPS_NPATCHES	equ 0x01000000

D3DPMISCCAPS_MASKZ	equ 0x00000002
D3DPMISCCAPS_LINEPATTERNREP equ 0x00000004
D3DPMISCCAPS_CULLNONE	equ 0x00000010
D3DPMISCCAPS_CULLCW	equ 0x00000020
D3DPMISCCAPS_CULLCCW	equ 0x00000040
D3DPMISCCAPS_COLORWRITEENABLE equ 0x00000080
D3DPMISCCAPS_CLIPPLANESCALEDPOINTS equ 0x00000100
D3DPMISCCAPS_CLIPTLVERTS equ 0x00000200
D3DPMISCCAPS_TSSARGTEMP equ 0x00000400
D3DPMISCCAPS_BLENDOP	equ 0x00000800
D3DPMISCCAPS_NULLREFERENCE equ 0x00001000

D3DLINECAPS_TEXTURE	equ 0x00000001
D3DLINECAPS_ZTEST	equ 0x00000002
D3DLINECAPS_BLEND	equ 0x00000004
D3DLINECAPS_ALPHACMP	equ 0x00000008
D3DLINECAPS_FOG		equ 0x00000010

D3DPRASTERCAPS_DITHER	equ 0x00000001
D3DPRASTERCAPS_PAT	equ 0x00000008
D3DPRASTERCAPS_ZTEST	equ 0x00000010
D3DPRASTERCAPS_FOGVERTEX equ 0x00000080
D3DPRASTERCAPS_FOGTABLE equ 0x00000100
D3DPRASTERCAPS_ANTIALIASEDGES equ 0x00001000
D3DPRASTERCAPS_MIPMAPLODBIAS equ 0x00002000
D3DPRASTERCAPS_ZBIAS	equ 0x00004000
D3DPRASTERCAPS_ZBUFFERLESSHSR equ 0x00008000
D3DPRASTERCAPS_FOGRANGE equ 0x00010000
D3DPRASTERCAPS_ANISOTROPY equ 0x00020000
D3DPRASTERCAPS_WBUFFER	equ 0x00040000
D3DPRASTERCAPS_WFOG	equ 0x00100000
D3DPRASTERCAPS_ZFOG	equ 0x00200000
D3DPRASTERCAPS_COLORPERSPECTIVE equ 0x00400000
D3DPRASTERCAPS_STRETCHBLTMULTISAMPLE equ 0x00800000

D3DPCMPCAPS_NEVER	equ 0x00000001
D3DPCMPCAPS_LESS	equ 0x00000002
D3DPCMPCAPS_EQUAL	equ 0x00000004
D3DPCMPCAPS_LESSEQUAL	equ 0x00000008
D3DPCMPCAPS_GREATER	equ 0x00000010
D3DPCMPCAPS_NOTEQUAL	equ 0x00000020
D3DPCMPCAPS_GREATEREQUAL equ 0x00000040
D3DPCMPCAPS_ALWAYS	equ 0x00000080

D3DPBLENDCAPS_ZERO	equ 0x00000001
D3DPBLENDCAPS_ONE	equ 0x00000002
D3DPBLENDCAPS_SRCCOLOR	equ 0x00000004
D3DPBLENDCAPS_INVSRCCOLOR equ 0x00000008
D3DPBLENDCAPS_SRCALPHA	equ 0x00000010
D3DPBLENDCAPS_INVSRCALPHA equ 0x00000020
D3DPBLENDCAPS_DESTALPHA equ 0x00000040
D3DPBLENDCAPS_INVDESTALPHA equ 0x00000080
D3DPBLENDCAPS_DESTCOLOR equ 0x00000100
D3DPBLENDCAPS_INVDESTCOLOR equ 0x00000200
D3DPBLENDCAPS_SRCALPHASAT equ 0x00000400
D3DPBLENDCAPS_BOTHSRCALPHA equ 0x00000800
D3DPBLENDCAPS_BOTHINVSRCALPHA equ 0x00001000

D3DPSHADECAPS_COLORGOURAUDRGB equ 0x00000008
D3DPSHADECAPS_SPECULARGOURAUDRGB equ 0x00000200
D3DPSHADECAPS_ALPHAGOURAUDBLEND equ 0x00004000
D3DPSHADECAPS_FOGGOURAUD equ 0x00080000

D3DPTEXTURECAPS_PERSPECTIVE equ 0x00000001
D3DPTEXTURECAPS_POW2	equ 0x00000002
D3DPTEXTURECAPS_ALPHA	equ 0x00000004
D3DPTEXTURECAPS_SQUAREONLY equ 0x00000020
D3DPTEXTURECAPS_TEXREPEATNOTSCALEDBYSIZE equ 0x00000040
D3DPTEXTURECAPS_ALPHAPALETTE equ 0x00000080
D3DPTEXTURECAPS_NONPOW2CONDITIONAL equ 0x00000100
D3DPTEXTURECAPS_PROJECTED equ 0x00000400
D3DPTEXTURECAPS_CUBEMAP equ 0x00000800
D3DPTEXTURECAPS_VOLUMEMAP equ 0x00002000
D3DPTEXTURECAPS_MIPMAP	equ 0x00004000
D3DPTEXTURECAPS_MIPVOLUMEMAP equ 0x00008000
D3DPTEXTURECAPS_MIPCUBEMAP equ 0x00010000
D3DPTEXTURECAPS_CUBEMAP_POW2 equ 0x00020000
D3DPTEXTURECAPS_VOLUMEMAP_POW2 equ 0x00040000

D3DPTFILTERCAPS_MINFPOINT equ 0x00000100
D3DPTFILTERCAPS_MINFLINEAR equ 0x00000200
D3DPTFILTERCAPS_MINFANISOTROPIC equ 0x00000400
D3DPTFILTERCAPS_MIPFPOINT equ 0x00010000
D3DPTFILTERCAPS_MIPFLINEAR equ 0x00020000
D3DPTFILTERCAPS_MAGFPOINT equ 0x01000000
D3DPTFILTERCAPS_MAGFLINEAR equ 0x02000000
D3DPTFILTERCAPS_MAGFANISOTROPIC equ 0x04000000
D3DPTFILTERCAPS_MAGFAFLATCUBIC equ 0x08000000
D3DPTFILTERCAPS_MAGFGAUSSIANCUBIC equ 0x10000000

D3DPTADDRESSCAPS_WRAP	equ 0x00000001
D3DPTADDRESSCAPS_MIRROR equ 0x00000002
D3DPTADDRESSCAPS_CLAMP	equ 0x00000004
D3DPTADDRESSCAPS_BORDER equ 0x00000008
D3DPTADDRESSCAPS_INDEPENDENTUV equ 0x00000010
D3DPTADDRESSCAPS_MIRRORONCE equ 0x00000020

D3DSTENCILCAPS_KEEP	equ 0x00000001
D3DSTENCILCAPS_ZERO	equ 0x00000002
D3DSTENCILCAPS_REPLACE	equ 0x00000004
D3DSTENCILCAPS_INCRSAT	equ 0x00000008
D3DSTENCILCAPS_DECRSAT	equ 0x00000010
D3DSTENCILCAPS_INVERT	equ 0x00000020
D3DSTENCILCAPS_INCR	equ 0x00000040
D3DSTENCILCAPS_DECR	equ 0x00000080

D3DTEXOPCAPS_DISABLE	equ 0x00000001
D3DTEXOPCAPS_SELECTARG1 equ 0x00000002
D3DTEXOPCAPS_SELECTARG2 equ 0x00000004
D3DTEXOPCAPS_MODULATE	equ 0x00000008
D3DTEXOPCAPS_MODULATE2X equ 0x00000010
D3DTEXOPCAPS_MODULATE4X equ 0x00000020
D3DTEXOPCAPS_ADD	equ 0x00000040
D3DTEXOPCAPS_ADDSIGNED	equ 0x00000080
D3DTEXOPCAPS_ADDSIGNED2X equ 0x00000100
D3DTEXOPCAPS_SUBTRACT	equ 0x00000200
D3DTEXOPCAPS_ADDSMOOTH	equ 0x00000400
D3DTEXOPCAPS_BLENDDIFFUSEALPHA equ 0x00000800
D3DTEXOPCAPS_BLENDTEXTUREALPHA equ 0x00001000
D3DTEXOPCAPS_BLENDFACTORALPHA equ 0x00002000
D3DTEXOPCAPS_BLENDTEXTUREALPHAPM equ 0x00004000
D3DTEXOPCAPS_BLENDCURRENTALPHA equ 0x00008000
D3DTEXOPCAPS_PREMODULATE equ 0x00010000
D3DTEXOPCAPS_MODULATEALPHA_ADDCOLOR equ 0x00020000
D3DTEXOPCAPS_MODULATECOLOR_ADDALPHA equ 0x00040000
D3DTEXOPCAPS_MODULATEINVALPHA_ADDCOLOR equ 0x00080000
D3DTEXOPCAPS_MODULATEINVCOLOR_ADDALPHA equ 0x00100000
D3DTEXOPCAPS_BUMPENVMAP equ 0x00200000
D3DTEXOPCAPS_BUMPENVMAPLUMINANCE equ 0x00400000
D3DTEXOPCAPS_DOTPRODUCT3 equ 0x00800000
D3DTEXOPCAPS_MULTIPLYADD equ 0x01000000
D3DTEXOPCAPS_LERP	equ 0x02000000

D3DFVFCAPS_TEXCOORDCOUNTMASK equ 0x0000ffff
D3DFVFCAPS_DONOTSTRIPELEMENTS equ 0x00080000
D3DFVFCAPS_PSIZE	equ 0x00100000

D3DVTXPCAPS_TEXGEN	equ 0x00000001
D3DVTXPCAPS_MATERIALSOURCE7 equ 0x00000002
D3DVTXPCAPS_DIRECTIONALLIGHTS equ 0x00000008
D3DVTXPCAPS_POSITIONALLIGHTS equ 0x00000010
D3DVTXPCAPS_LOCALVIEWER equ 0x00000020
D3DVTXPCAPS_TWEENING	equ 0x00000040
D3DVTXPCAPS_NO_VSDT_UBYTE4 equ 0x00000080

.pragma pack(pop)

endif
endif

