ifndef __dxgiformat_h__
define __dxgiformat_h__

DXGI_FORMAT_DEFINED     equ 1

DXGI_FORMAT             typedef SDWORD
DXGI_FORMAT_UNKNOWN     equ 0
DXGI_FORMAT_R32G32B32A32_TYPELESS equ 1
DXGI_FORMAT_R32G32B32A32_FLOAT equ 2
DXGI_FORMAT_R32G32B32A32_UINT equ 3
DXGI_FORMAT_R32G32B32A32_SINT equ 4
DXGI_FORMAT_R32G32B32_TYPELESS equ 5
DXGI_FORMAT_R32G32B32_FLOAT equ 6
DXGI_FORMAT_R32G32B32_UINT equ 7
DXGI_FORMAT_R32G32B32_SINT equ 8
DXGI_FORMAT_R16G16B16A16_TYPELESS equ 9
DXGI_FORMAT_R16G16B16A16_FLOAT equ 10
DXGI_FORMAT_R16G16B16A16_UNORM equ 11
DXGI_FORMAT_R16G16B16A16_UINT equ 12
DXGI_FORMAT_R16G16B16A16_SNORM equ 13
DXGI_FORMAT_R16G16B16A16_SINT equ 14
DXGI_FORMAT_R32G32_TYPELESS equ 15
DXGI_FORMAT_R32G32_FLOAT equ 16
DXGI_FORMAT_R32G32_UINT equ 17
DXGI_FORMAT_R32G32_SINT equ 18
DXGI_FORMAT_R32G8X24_TYPELESS equ 19
DXGI_FORMAT_D32_FLOAT_S8X24_UINT equ 20
DXGI_FORMAT_R32_FLOAT_X8X24_TYPELESS equ 21
DXGI_FORMAT_X32_TYPELESS_G8X24_UINT equ 22
DXGI_FORMAT_R10G10B10A2_TYPELESS equ 23
DXGI_FORMAT_R10G10B10A2_UNORM equ 24
DXGI_FORMAT_R10G10B10A2_UINT equ 25
DXGI_FORMAT_R11G11B10_FLOAT equ 26
DXGI_FORMAT_R8G8B8A8_TYPELESS equ 27
DXGI_FORMAT_R8G8B8A8_UNORM equ 28
DXGI_FORMAT_R8G8B8A8_UNORM_SRGB equ 29
DXGI_FORMAT_R8G8B8A8_UINT equ 30
DXGI_FORMAT_R8G8B8A8_SNORM equ 31
DXGI_FORMAT_R8G8B8A8_SINT equ 32
DXGI_FORMAT_R16G16_TYPELESS equ 33
DXGI_FORMAT_R16G16_FLOAT equ 34
DXGI_FORMAT_R16G16_UNORM equ 35
DXGI_FORMAT_R16G16_UINT equ 36
DXGI_FORMAT_R16G16_SNORM equ 37
DXGI_FORMAT_R16G16_SINT equ 38
DXGI_FORMAT_R32_TYPELESS equ 39
DXGI_FORMAT_D32_FLOAT   equ 40
DXGI_FORMAT_R32_FLOAT   equ 41
DXGI_FORMAT_R32_UINT    equ 42
DXGI_FORMAT_R32_SINT    equ 43
DXGI_FORMAT_R24G8_TYPELESS equ 44
DXGI_FORMAT_D24_UNORM_S8_UINT equ 45
DXGI_FORMAT_R24_UNORM_X8_TYPELESS equ 46
DXGI_FORMAT_X24_TYPELESS_G8_UINT equ 47
DXGI_FORMAT_R8G8_TYPELESS equ 48
DXGI_FORMAT_R8G8_UNORM  equ 49
DXGI_FORMAT_R8G8_UINT   equ 50
DXGI_FORMAT_R8G8_SNORM  equ 51
DXGI_FORMAT_R8G8_SINT   equ 52
DXGI_FORMAT_R16_TYPELESS equ 53
DXGI_FORMAT_R16_FLOAT   equ 54
DXGI_FORMAT_D16_UNORM   equ 55
DXGI_FORMAT_R16_UNORM   equ 56
DXGI_FORMAT_R16_UINT    equ 57
DXGI_FORMAT_R16_SNORM   equ 58
DXGI_FORMAT_R16_SINT    equ 59
DXGI_FORMAT_R8_TYPELESS equ 60
DXGI_FORMAT_R8_UNORM    equ 61
DXGI_FORMAT_R8_UINT     equ 62
DXGI_FORMAT_R8_SNORM    equ 63
DXGI_FORMAT_R8_SINT     equ 64
DXGI_FORMAT_A8_UNORM    equ 65
DXGI_FORMAT_R1_UNORM    equ 66
DXGI_FORMAT_R9G9B9E5_SHAREDEXP equ 67
DXGI_FORMAT_R8G8_B8G8_UNORM equ 68
DXGI_FORMAT_G8R8_G8B8_UNORM equ 69
DXGI_FORMAT_BC1_TYPELESS equ 70
DXGI_FORMAT_BC1_UNORM   equ 71
DXGI_FORMAT_BC1_UNORM_SRGB equ 72
DXGI_FORMAT_BC2_TYPELESS equ 73
DXGI_FORMAT_BC2_UNORM   equ 74
DXGI_FORMAT_BC2_UNORM_SRGB equ 75
DXGI_FORMAT_BC3_TYPELESS equ 76
DXGI_FORMAT_BC3_UNORM   equ 77
DXGI_FORMAT_BC3_UNORM_SRGB equ 78
DXGI_FORMAT_BC4_TYPELESS equ 79
DXGI_FORMAT_BC4_UNORM   equ 80
DXGI_FORMAT_BC4_SNORM   equ 81
DXGI_FORMAT_BC5_TYPELESS equ 82
DXGI_FORMAT_BC5_UNORM   equ 83
DXGI_FORMAT_BC5_SNORM   equ 84
DXGI_FORMAT_B5G6R5_UNORM equ 85
DXGI_FORMAT_B5G5R5A1_UNORM equ 86
DXGI_FORMAT_B8G8R8A8_UNORM equ 87
DXGI_FORMAT_B8G8R8X8_UNORM equ 88
DXGI_FORMAT_R10G10B10_XR_BIAS_A2_UNORM equ 89
DXGI_FORMAT_B8G8R8A8_TYPELESS equ 90
DXGI_FORMAT_B8G8R8A8_UNORM_SRGB equ 91
DXGI_FORMAT_B8G8R8X8_TYPELESS equ 92
DXGI_FORMAT_B8G8R8X8_UNORM_SRGB equ 93
DXGI_FORMAT_BC6H_TYPELESS equ 94
DXGI_FORMAT_BC6H_UF16   equ 95
DXGI_FORMAT_BC6H_SF16   equ 96
DXGI_FORMAT_BC7_TYPELESS equ 97
DXGI_FORMAT_BC7_UNORM   equ 98
DXGI_FORMAT_BC7_UNORM_SRGB equ 99
DXGI_FORMAT_FORCE_UINT  equ 0xffffffff

endif
