ifndef FTOPTION_H_
define FTOPTION_H_

include ft2build.inc

FT_BEGIN_HEADER

define FT_CONFIG_OPTION_ENVIRONMENT_PROPERTIES
undef FT_CONFIG_OPTION_FORCE_INT64

define FT_CONFIG_OPTION_INLINE_MULFIX
define FT_CONFIG_OPTION_USE_LZW
define FT_CONFIG_OPTION_USE_ZLIB
define FT_CONFIG_OPTION_SYSTEM_ZLIB
define FT_CONFIG_OPTION_USE_PNG
define FT_CONFIG_OPTION_POSTSCRIPT_NAMES
define FT_CONFIG_OPTION_ADOBE_GLYPH_LIST
define FT_CONFIG_OPTION_MAC_FONTS
ifdef FT_CONFIG_OPTION_MAC_FONTS
define FT_CONFIG_OPTION_GUESSING_EMBEDDED_RFORK
endif
define FT_CONFIG_OPTION_INCREMENTAL

define FT_RENDER_POOL_SIZE  16384
define FT_MAX_MODULES  32

undef FT_CONFIG_OPTION_USE_MODULE_ERRORS

define FT_CONFIG_OPTION_SVG

define TT_CONFIG_OPTION_EMBEDDED_BITMAPS
define TT_CONFIG_OPTION_COLOR_LAYERS
define TT_CONFIG_OPTION_POSTSCRIPT_NAMES
define TT_CONFIG_OPTION_SFNT_NAMES

define TT_CONFIG_CMAP_FORMAT_0
define TT_CONFIG_CMAP_FORMAT_2
define TT_CONFIG_CMAP_FORMAT_4
define TT_CONFIG_CMAP_FORMAT_6
define TT_CONFIG_CMAP_FORMAT_8
define TT_CONFIG_CMAP_FORMAT_10
define TT_CONFIG_CMAP_FORMAT_12
define TT_CONFIG_CMAP_FORMAT_13
define TT_CONFIG_CMAP_FORMAT_14

define TT_CONFIG_OPTION_BYTECODE_INTERPRETER
define TT_CONFIG_OPTION_SUBPIXEL_HINTING  2

undef TT_CONFIG_OPTION_COMPONENT_OFFSET_SCALED

define TT_CONFIG_OPTION_GX_VAR_SUPPORT
define TT_CONFIG_OPTION_BDF

ifndef TT_CONFIG_OPTION_MAX_RUNNABLE_OPCODES
define TT_CONFIG_OPTION_MAX_RUNNABLE_OPCODES  1000000L
endif

define T1_MAX_DICT_DEPTH  5
define T1_MAX_SUBRS_CALLS  16
define T1_MAX_CHARSTRINGS_OPERANDS  256

undef T1_CONFIG_OPTION_NO_AFM
undef T1_CONFIG_OPTION_NO_MM_SUPPORT

define CFF_CONFIG_OPTION_DARKENING_PARAMETER_X1   500
define CFF_CONFIG_OPTION_DARKENING_PARAMETER_Y1   400

define CFF_CONFIG_OPTION_DARKENING_PARAMETER_X2  1000
define CFF_CONFIG_OPTION_DARKENING_PARAMETER_Y2   275

define CFF_CONFIG_OPTION_DARKENING_PARAMETER_X3  1667
define CFF_CONFIG_OPTION_DARKENING_PARAMETER_Y3   275

define CFF_CONFIG_OPTION_DARKENING_PARAMETER_X4  2333
define CFF_CONFIG_OPTION_DARKENING_PARAMETER_Y4     0

define AF_CONFIG_OPTION_CJK

ifdef AF_CONFIG_OPTION_CJK
define AF_CONFIG_OPTION_INDIC
endif

ifdef TT_CONFIG_OPTION_BYTECODE_INTERPRETER
define  TT_USE_BYTECODE_INTERPRETER

ifdef TT_CONFIG_OPTION_SUBPIXEL_HINTING
if TT_CONFIG_OPTION_SUBPIXEL_HINTING AND 1
define  TT_SUPPORT_SUBPIXEL_HINTING_INFINALITY
endif

if TT_CONFIG_OPTION_SUBPIXEL_HINTING AND 2
define  TT_SUPPORT_SUBPIXEL_HINTING_MINIMAL
endif
endif
endif

ifdef TT_CONFIG_OPTION_COLOR_LAYERS
define  TT_SUPPORT_COLRV1
endif

if CFF_CONFIG_OPTION_DARKENING_PARAMETER_X1 LT 0 OR \
   CFF_CONFIG_OPTION_DARKENING_PARAMETER_X2 LT 0 OR \
   CFF_CONFIG_OPTION_DARKENING_PARAMETER_X3 LT 0 OR \
   CFF_CONFIG_OPTION_DARKENING_PARAMETER_X4 LT 0 OR \
   CFF_CONFIG_OPTION_DARKENING_PARAMETER_Y1 LT 0 OR \
   CFF_CONFIG_OPTION_DARKENING_PARAMETER_Y2 LT 0 OR \
   CFF_CONFIG_OPTION_DARKENING_PARAMETER_Y3 LT 0 OR \
   CFF_CONFIG_OPTION_DARKENING_PARAMETER_Y4 LT 0 OR \
   CFF_CONFIG_OPTION_DARKENING_PARAMETER_X1 GT CFF_CONFIG_OPTION_DARKENING_PARAMETER_X2 OR \
   CFF_CONFIG_OPTION_DARKENING_PARAMETER_X2 GT CFF_CONFIG_OPTION_DARKENING_PARAMETER_X3 OR \
   CFF_CONFIG_OPTION_DARKENING_PARAMETER_X3 GT CFF_CONFIG_OPTION_DARKENING_PARAMETER_X4 OR \
   CFF_CONFIG_OPTION_DARKENING_PARAMETER_Y1 GT 500 OR \
   CFF_CONFIG_OPTION_DARKENING_PARAMETER_Y2 GT 500 OR \
   CFF_CONFIG_OPTION_DARKENING_PARAMETER_Y3 GT 500 OR \
   CFF_CONFIG_OPTION_DARKENING_PARAMETER_Y4 GT 500
.err <"Invalid CFF darkening parameters!">
endif

FT_END_HEADER

endif
