if defined(GDK_PIXBUF_DISABLE_SINGLE_INCLUDES) AND NOT defined (GDK_PIXBUF_H_INSIDE) AND NOT defined (GDK_PIXBUF_COMPILATION)
.err <"Only gdk-pixbuf/gdk-pixbuf.h can be included directly.">
endif

ifndef GDK_PIXBUF_MACROS_H
define GDK_PIXBUF_MACROS_H

include glib.inc

include gdk-pixbuf/gdk-pixbuf-features.inc

GDK_PIXBUF_CHECK_VERSION macro major, minor, micro
if (GDK_PIXBUF_MAJOR gt (major) or (GDK_PIXBUF_MAJOR eq (major) and GDK_PIXBUF_MINOR gt (minor)) or (GDK_PIXBUF_MAJOR eq (major) and GDK_PIXBUF_MINOR == (minor) and GDK_PIXBUF_MICRO ge (micro)))
	exitm<1>
else
	exitm<0>
endif
	endm

GDK_PIXBUF_VERSION_2_0	equ (G_ENCODE_VERSION (2, 0))
GDK_PIXBUF_VERSION_2_2	equ (G_ENCODE_VERSION (2, 2))
GDK_PIXBUF_VERSION_2_4	equ (G_ENCODE_VERSION (2, 4))
GDK_PIXBUF_VERSION_2_6	equ (G_ENCODE_VERSION (2, 6))
GDK_PIXBUF_VERSION_2_8	equ (G_ENCODE_VERSION (2, 8))
GDK_PIXBUF_VERSION_2_10 equ (G_ENCODE_VERSION (2, 10))
GDK_PIXBUF_VERSION_2_12 equ (G_ENCODE_VERSION (2, 12))
GDK_PIXBUF_VERSION_2_14 equ (G_ENCODE_VERSION (2, 14))
GDK_PIXBUF_VERSION_2_16 equ (G_ENCODE_VERSION (2, 16))
GDK_PIXBUF_VERSION_2_18 equ (G_ENCODE_VERSION (2, 18))
GDK_PIXBUF_VERSION_2_20 equ (G_ENCODE_VERSION (2, 20))
GDK_PIXBUF_VERSION_2_22 equ (G_ENCODE_VERSION (2, 22))
GDK_PIXBUF_VERSION_2_24 equ (G_ENCODE_VERSION (2, 24))
GDK_PIXBUF_VERSION_2_26 equ (G_ENCODE_VERSION (2, 26))
GDK_PIXBUF_VERSION_2_28 equ (G_ENCODE_VERSION (2, 28))
GDK_PIXBUF_VERSION_2_30 equ (G_ENCODE_VERSION (2, 30))
GDK_PIXBUF_VERSION_2_32 equ (G_ENCODE_VERSION (2, 32))
GDK_PIXBUF_VERSION_2_34 equ (G_ENCODE_VERSION (2, 34))
GDK_PIXBUF_VERSION_2_36 equ (G_ENCODE_VERSION (2, 36))
GDK_PIXBUF_VERSION_2_38 equ (G_ENCODE_VERSION (2, 38))
GDK_PIXBUF_VERSION_2_40 equ (G_ENCODE_VERSION (2, 40))

ifndef __GTK_DOC_IGNORE__
if (GDK_PIXBUF_MINOR mod 2)
GDK_PIXBUF_VERSION_CUR_STABLE equ (G_ENCODE_VERSION (GDK_PIXBUF_MAJOR, GDK_PIXBUF_MINOR + 1))
else
GDK_PIXBUF_VERSION_CUR_STABLE equ (G_ENCODE_VERSION (GDK_PIXBUF_MAJOR, GDK_PIXBUF_MINOR))
endif
endif

ifndef __GTK_DOC_IGNORE__
if (GDK_PIXBUF_MINOR mod 2)
GDK_PIXBUF_VERSION_PREV_STABLE equ (G_ENCODE_VERSION (GDK_PIXBUF_MAJOR, GDK_PIXBUF_MINOR - 1))
else
GDK_PIXBUF_VERSION_PREV_STABLE equ (G_ENCODE_VERSION (GDK_PIXBUF_MAJOR, GDK_PIXBUF_MINOR - 2))
endif
endif

ifndef GDK_PIXBUF_VERSION_MIN_REQUIRED
GDK_PIXBUF_VERSION_MIN_REQUIRED equ (GDK_PIXBUF_VERSION_CUR_STABLE)
endif

ifndef GDK_PIXBUF_VERSION_MAX_ALLOWED
if GDK_PIXBUF_VERSION_MIN_REQUIRED GT GDK_PIXBUF_VERSION_PREV_STABLE
define GDK_PIXBUF_VERSION_MAX_ALLOWED GDK_PIXBUF_VERSION_MIN_REQUIRED
else
define GDK_PIXBUF_VERSION_MAX_ALLOWED GDK_PIXBUF_VERSION_CUR_STABLE
endif
endif

if GDK_PIXBUF_VERSION_MAX_ALLOWED LT GDK_PIXBUF_VERSION_MIN_REQUIRED
.err <"GDK_PIXBUF_VERSION_MAX_ALLOWED must be >= GDK_PIXBUF_VERSION_MIN_REQUIRED">
endif
if GDK_PIXBUF_VERSION_MIN_REQUIRED LT GDK_PIXBUF_VERSION_2_0
.err <"GDK_PIXBUF_VERSION_MIN_REQUIRED must be >= GDK_PIXBUF_VERSION_2_0">
endif

endif
