ifndef __PANGO_SCRIPT_H__
define __PANGO_SCRIPT_H__

include glib-object.inc

.enum PangoScript {
    PANGO_SCRIPT_INVALID_CODE = -1,
    PANGO_SCRIPT_COMMON	      = 0,
    PANGO_SCRIPT_INHERITED,
    PANGO_SCRIPT_ARABIC,
    PANGO_SCRIPT_ARMENIAN,
    PANGO_SCRIPT_BENGALI,
    PANGO_SCRIPT_BOPOMOFO,
    PANGO_SCRIPT_CHEROKEE,
    PANGO_SCRIPT_COPTIC,
    PANGO_SCRIPT_CYRILLIC,
    PANGO_SCRIPT_DESERET,
    PANGO_SCRIPT_DEVANAGARI,
    PANGO_SCRIPT_ETHIOPIC,
    PANGO_SCRIPT_GEORGIAN,
    PANGO_SCRIPT_GOTHIC,
    PANGO_SCRIPT_GREEK,
    PANGO_SCRIPT_GUJARATI,
    PANGO_SCRIPT_GURMUKHI,
    PANGO_SCRIPT_HAN,
    PANGO_SCRIPT_HANGUL,
    PANGO_SCRIPT_HEBREW,
    PANGO_SCRIPT_HIRAGANA,
    PANGO_SCRIPT_KANNADA,
    PANGO_SCRIPT_KATAKANA,
    PANGO_SCRIPT_KHMER,
    PANGO_SCRIPT_LAO,
    PANGO_SCRIPT_LATIN,
    PANGO_SCRIPT_MALAYALAM,
    PANGO_SCRIPT_MONGOLIAN,
    PANGO_SCRIPT_MYANMAR,
    PANGO_SCRIPT_OGHAM,
    PANGO_SCRIPT_OLD_ITALIC,
    PANGO_SCRIPT_ORIYA,
    PANGO_SCRIPT_RUNIC,
    PANGO_SCRIPT_SINHALA,
    PANGO_SCRIPT_SYRIAC,
    PANGO_SCRIPT_TAMIL,
    PANGO_SCRIPT_TELUGU,
    PANGO_SCRIPT_THAANA,
    PANGO_SCRIPT_THAI,
    PANGO_SCRIPT_TIBETAN,
    PANGO_SCRIPT_CANADIAN_ABORIGINAL,
    PANGO_SCRIPT_YI,
    PANGO_SCRIPT_TAGALOG,
    PANGO_SCRIPT_HANUNOO,
    PANGO_SCRIPT_BUHID,
    PANGO_SCRIPT_TAGBANWA,
    PANGO_SCRIPT_BRAILLE,
    PANGO_SCRIPT_CYPRIOT,
    PANGO_SCRIPT_LIMBU,
    PANGO_SCRIPT_OSMANYA,
    PANGO_SCRIPT_SHAVIAN,
    PANGO_SCRIPT_LINEAR_B,
    PANGO_SCRIPT_TAI_LE,
    PANGO_SCRIPT_UGARITIC,
    PANGO_SCRIPT_NEW_TAI_LUE,
    PANGO_SCRIPT_BUGINESE,
    PANGO_SCRIPT_GLAGOLITIC,
    PANGO_SCRIPT_TIFINAGH,
    PANGO_SCRIPT_SYLOTI_NAGRI,
    PANGO_SCRIPT_OLD_PERSIAN,
    PANGO_SCRIPT_KHAROSHTHI,
    PANGO_SCRIPT_UNKNOWN,
    PANGO_SCRIPT_BALINESE,
    PANGO_SCRIPT_CUNEIFORM,
    PANGO_SCRIPT_PHOENICIAN,
    PANGO_SCRIPT_PHAGS_PA,
    PANGO_SCRIPT_NKO,
    PANGO_SCRIPT_KAYAH_LI,
    PANGO_SCRIPT_LEPCHA,
    PANGO_SCRIPT_REJANG,
    PANGO_SCRIPT_SUNDANESE,
    PANGO_SCRIPT_SAURASHTRA,
    PANGO_SCRIPT_CHAM,
    PANGO_SCRIPT_OL_CHIKI,
    PANGO_SCRIPT_VAI,
    PANGO_SCRIPT_CARIAN,
    PANGO_SCRIPT_LYCIAN,
    PANGO_SCRIPT_LYDIAN,
    PANGO_SCRIPT_BATAK,
    PANGO_SCRIPT_BRAHMI,
    PANGO_SCRIPT_MANDAIC,
    PANGO_SCRIPT_CHAKMA,
    PANGO_SCRIPT_MEROITIC_CURSIVE,
    PANGO_SCRIPT_MEROITIC_HIEROGLYPHS,
    PANGO_SCRIPT_MIAO,
    PANGO_SCRIPT_SHARADA,
    PANGO_SCRIPT_SORA_SOMPENG,
    PANGO_SCRIPT_TAKRI,
    PANGO_SCRIPT_BASSA_VAH,
    PANGO_SCRIPT_CAUCASIAN_ALBANIAN,
    PANGO_SCRIPT_DUPLOYAN,
    PANGO_SCRIPT_ELBASAN,
    PANGO_SCRIPT_GRANTHA,
    PANGO_SCRIPT_KHOJKI,
    PANGO_SCRIPT_KHUDAWADI,
    PANGO_SCRIPT_LINEAR_A,
    PANGO_SCRIPT_MAHAJANI,
    PANGO_SCRIPT_MANICHAEAN,
    PANGO_SCRIPT_MENDE_KIKAKUI,
    PANGO_SCRIPT_MODI,
    PANGO_SCRIPT_MRO,
    PANGO_SCRIPT_NABATAEAN,
    PANGO_SCRIPT_OLD_NORTH_ARABIAN,
    PANGO_SCRIPT_OLD_PERMIC,
    PANGO_SCRIPT_PAHAWH_HMONG,
    PANGO_SCRIPT_PALMYRENE,
    PANGO_SCRIPT_PAU_CIN_HAU,
    PANGO_SCRIPT_PSALTER_PAHLAVI,
    PANGO_SCRIPT_SIDDHAM,
    PANGO_SCRIPT_TIRHUTA,
    PANGO_SCRIPT_WARANG_CITI,
    PANGO_SCRIPT_AHOM,
    PANGO_SCRIPT_ANATOLIAN_HIEROGLYPHS,
    PANGO_SCRIPT_HATRAN,
    PANGO_SCRIPT_MULTANI,
    PANGO_SCRIPT_OLD_HUNGARIAN,
    PANGO_SCRIPT_SIGNWRITING
    }

include pango/pango-version-macros.inc

pango_script_for_unichar proto __cdecl \
		      : gunichar

pango_script_iter_get_type proto __cdecl

pango_script_iter_new proto __cdecl \
		      : ptr,
		length: SINT
;void
pango_script_iter_get_range proto __cdecl \
		  iter: ptr PangoScriptIter,
		 start: ptr char_t,
		  _end: ptr char_t,
		script: ptr PangoScript

pango_script_iter_next proto __cdecl \
		  iter: ptr PangoScriptIter

;void
pango_script_iter_free proto __cdecl \
		  iter: ptr PangoScriptIter

include pango/pango-language.inc

pango_script_get_sample_language proto __cdecl \
		script: PangoScript

endif
